(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)















Needs["Graphics`Colors`"]

BeginPackage["TensorCalculus3`Tensorial`"];





Tensor::usage="Tensor[A, upindices, downindices] represents a tensor with the \
label A and the given up and down indices. The list of up and down indices \
must be equal in length. Missing indices are indicated by Void.";

Void::usage = "Void is used to indicate a blank slot in the up or down tensor \
indices.";

Dif::usage="Dif[index] is the internal representation for partial \
differentation of an index."

Cov::usage="Cov[index] is the internal representation for covariant \
differentation of an index."

SetDerivativeSymbols::usage="SetDerivativeSymbols[{\",\", \";\", \"\
\[DifferentialD]\", \"\[DifferentialD]\", \"D\", \
\"d\",\"\[ScriptCapitalL]\"}] sets the output format derivative symbols to \
the list of characters. The list is {DifSym, CovSym, TotalDupSym, \
TotalDdownSym, AbsoluteDupSym, AbsoluteDdownSym, LieDSym}. The default values \
are as shown. To change one you must reset the entire list."



ToArrayValues::usage="ToArrayValues[expr] will convert the expression to a \
vector, matrix or array by expansion and substitution of any stored values.";

ContractArray::usage="ContractArray[tarray, {lev1, lev2}..] will contract the \
indicated pairs of level numbers in the tensor array tarray.";



BaseIndices::usage="BaseIndices is the current list of symbols or integers \
being used to index the coordinates.";

DeclareBaseIndices::usage="DeclareBaseIndices[indexlist] sets the number and \
values of the base indices. Examples: {1,2,3}, {0,1,2,3}, {t,x,y,z}. The \
number of base indices determines NDim, the dimension of the underlying \
vector space. The indices are stored in BaseIndices.";

NDim::usage="NDim is the current dimension of the space, obtained from the \
length of the BaseIndices list.";

BaseIndexQ::usage="BaseIndexQ[index] returns True if index has a base index \
value as its raw index and False otherwise. For example Cov[red[1]] returns \
True if 1 is one of the base indices.";



CircleTimes::usage="CircleTimes is used to represent full form tensor \
products. It maintains the order of tensor factors.";

LinearBreakout::usage="LinearBreakout[f1, f2,...][v1, v2,...][expr] will \
break out the linear terms of any expressions within expr that have heads \
matching the patterns fi over variables matching the patterns vj. Example:\n \
f[a x + b y]//LinearBreakout[f][x,y] \[Rule] a f[x] + b f[y]";

PushOnto::usage="PushOnto[argslist, ontolist][expr] is a form of the Through \
command that pushes arguments only onto forms given in the ontolist.\n\
PushOnto[ontolist][(head)[args]] pushes args onto forms given in the ontolist"

CircleEvalRule::usage="CircleEvalRule resolves expressions like\n(v1\
\[CircleTimes]v2\[CircleTimes]v3\[CircleTimes]v4)[w1,,w3,] \[Rule] v2\
\[CircleTimes]v4 v1.w1 v3.w3 \ninto dot products and reduced tensor terms.";

EvaluateSlots::usage=
    "EvaluateSlots[e, g][expr] will evaluate tensor products, involving \
CircleTimes, on a list of argument slots, which may contain Nulls. The tensor \
product and slots must be indicial expressions involving basis tensors e. g \
is the label for the metric tensor. It is assumed that shortcuts have been \
defined for e and g.";

BasisDotProductRules::usage="BasisDotProductRules[b, g] creates the dot \
product simplification rules for basis vectors. These convert dot products of \
basis vectors to the corresponding metric tensors. b is the label used for \
basis vectors and g is the label used for the metric tensor.";

ReverseBasisDotProductRules::usage="ReverseBasisDotProductRules[b, g] creates \
the rules that convert metric tensors into dot products of the basis vectors. \
b is the label used for basis vectors and g is the label used for the metric \
tensor.";

EvaluateDotProducts::usage="EvaluateDotProducts[e, g][expr] evaluates all Dot \
products in expr assuming that e are the basis vectors and g is the metric \
tensor.";

ConstructDirectProduct::usage="ConstructDirectProduct[expr] will convert a \
direct product of tensor slot expressions to an expression with a single set \
of slots. Example:\nS[w,x]\[CircleTimes]T[y,z]//ConstructDirectProduct \
\[Rule] (S\[CircleTimes]T)[w,x,y,z]. S and T may also be CircleTimes \
expressions involving basis vectors.";

GenerateBasisTensors::usage="GenerateBasisTensors[e, configuration] will \
generate the set of basis tensors on basis vectors e with a given \
configuration of up and down basis vectors. The configuration is specified by \
a String of u's and d's for up and down. It is assumed that tensor shortcuts \
have been defined for e.";

UsePartialDChainRule::usage=
    "UsePartialDChainRule[coordtensor][expr] will rewrite single partial \
derivatives in expr using the chain rule with respect to coordtensor.\n\
UsePartialDChainRule[diffvar1, diffvar2][expr] will rewrite single or \
multiple partial derivatives with respect to diffvar2 using the chain rule on \
diffvar1.";

UseTotalDChainRule::usage=
    "UseTotalDChainRule[coordtensor, labels][expr] will rewrite single total \
derivatives in expr using the chain rule with respect to coordtensor using \
labels as the standard set of labels.";



ParseTermIndices::usage="ParseTermIndices[term] will return the lists of \
indices:\n{dummies, {freeup, freedown}, bad}\n Dummies are indicies that \
occur up and down exactly once. Free indicies are ones that occur only once. \
All other indicies that appear in the term are bad.";

RawIndex::usage="RawIndex[index] will extract the raw index from a flavored \
and/or differentiated index. If the raw index is not a Symbol or Integer an \
error message is issued.";

RawIndex::notindex="`` is not a Symbol, Integer or Flavor.";

ExtractFreeIndices::usage="ExtractFreeIndices[expr] will generate a list, \
{{upindices...}, {downindices...}}, of free indices for expr. The up and down \
indices are sorted in standard order. Expr must be an equation with a sum of \
tensor terms on each side, or a simple sum of tensor terms. If the terms \
don't all have the same free indices an error message is generated and False \
is returned.";

FreeIndices::usage="FreeIndices::notmatched is a error message.";

FreeIndices::notmatched="The free indices are not the same in all terms of \
the expression or some terms have bad indices.";

SymbolicIndexQ::usage="SymbolicIndexQ[index] returns true if index is a \
Symbol or if index is flavor[i_Symbol] where flavor is a currently active \
flavor.";

RaiseIndex::usage="RaiseIndex[i,j][tensor] will raise the lower index i in \
tensor and rename it j.";

RaiseIndex::noindex="`` is not a lower index in ``";

LowerIndex::usage="LowerIndex[i,j][tensor] will lower the upper index i in \
tensor and rename it j.";

LowerIndex::noindex="`` is not an upper index in ``";

ReplaceIndex::usage="ReplaceIndex[i,j][tensor] will replace the index i in \
tensor and rename it j.";

ReplaceIndex::noindex="`` is not an index in ``";

IndexChange::usage=
    "IndexChange[{{r, i}, {s, j}...}, sign:1][expr] will replace the first \
index in each pair list by the second index in the pair list and multiply the \
expression by sign, which has the default value of 1./nIndexChange[{r,i}, \
sign:1][expr] may be used in the case of a single index change.";

UpDownSwap::usage="UpDownSwap[dummyindex][term] will swap the up-down \
positions of the dummy index in the term consisting of simple tensor \
products. At present, the dummy index can't be a covariant derivative index \
or in a Christoffel symbol.";

UpDownSwap::index="The index `` is not a proper dummy index in ``.";

UpDownSwap::term="`` is not a proper tensor term.";

DummySimplify::usage ="DummySimplify[expr] will attempt to simplify the dummy \
indices in the tensor expression to produce a minimum number of dummy \
indices.";

SimplifyTensorSum::usage="SimplifyTensorSum[sum] will check that all terms in \
a tensor sum have valid indices, that the free indices are the same in all \
terms, and will simplify the sum by using a minimum number of dummy indices.";

SimplifyTensorSum::badterm="Term `` contains bad indices.";

SimplifyTensorSum::free="Free indices are not the same in all terms.";

MapLevelParts::usage=
    "MapLevelParts[function, {topposition, levelpositions}][expr] will map \
the function onto the selected level positions in an expression. \
Levelpositions is a list of the selected parts. The function is applied to \
them as a group and they are replaced with a single new expression. Other \
parts not specified in levelpositions are left unchanged.\nExample:\na + b + \
c + d + e // MapLevelParts[f, {{2,4,5}}] -> a + c + f[b + d + e]";



SumExpansion::usage="SumExpansion[i,j,.., base:BaseIndices][expr] will sum on \
the indices, i, j,..., in the expression. The indices must carry their \
flavors. The expansions will be done on individual terms on both sides of an \
equation and within arrays. The range of the sum is over the base list which \
has the default value of BaseIndices.\nSumExpansion[{i,j,..}, \
base:BaseIndices][expr] may also be used.";

ArrayExpansion::usage="ArrayExpansion[i,j,.., base:BaseIndices][expr] will \
form an array on the indices, i, j,..., in the expression. The indices must \
carry their flavors. The first index will be at the highest level in the \
expansion array. The range of the expansion is over the base list which has \
the default value of BaseIndices.\nArrayExpansion[{i,j,..}, \
base:BaseIndices][expr] may also be used.";

SumArrayExpansion::subset="`` is not a subset of the BaseIndices ``";

EinsteinSum::usage="EinsteinSum[base:BaseIndices][expr] will do an Einstein \
summation individually on all terms on both sides of an equation, or all \
terms in a sum, or on a single term. The range of the sum is over the base \
list which has the default value of BaseIndices.";

EinsteinArray::usage="EinsteinArray[base:BaseIndices][expr] will do an array \
expansion on the free indices in the expression. The expansion will be done \
in the sort order of the free indices. The range of the expansion is over the \
BaseIndices.";

PartialSum::usage=
    "PartialSum[baseindex, newindices][expr] will expand dummy summations of \
a tensor expression into components that have one or more baseindex and \
unexpanded remainders. The elements are returned as a sum. Newindices is a \
list of indices that are used to replace the existing free indices in the \
expression. Greek indices might be replaced with Latin indices to indicate a \
restricted further expansion. PartialSum is mapped over arrays, equations and \
sums.";

PartialSum::newindices=
    "New indices ``, after removing freeindices ``, are insufficient to \
replace ``";

PartialSum::baseindex="The base index ``, is not in BaseIndices ``";

PartialArray::usage=
    "PartialArray[baseindex, newindices][expr] will expand the free indices \
of a tensor expression into components that have one or more baseindex \
indices and an unexpanded remainder. The elements are returned as a List. \
Newindices is a list of indices that are used to replace the existing free \
indices in the expression. Greek indices might be replaced with Latin indices \
to indicate a restricted further expansion. PartialArray is mapped over \
arrays, equations and sums.";

PartialArray::newindices=
    "New indices ``, after removing dummies ``, are insufficient to replace \
``";

PartialArray::baseindex="The base index ``, is not in BaseIndices ``";



IndexFlavors::usage="IndexFlavors is a list of the currently declared index \
flavors. It has the form {{flavorname, flavorform}...} where flavorname is a \
symbol, such as red or rocket, and flavorform is either an RGBColor or a \
header such as OverHat.";

DeclareIndexFlavor::usage="DeclareIndexFlavor[{flavorname, flavorform}] will \
add the index flavor to the IndexFlavors list and establish the Format for \
displaying indices with the given flavorname. If flavorform is an RGBColor, \
the index will be displayed in the given color, otherwise an index i will be \
displayed as flavorform[i], for example OverHat[i].";

ToFlavor::usage="ToFlavor[toflavor, fromflavor:Identity][expr] will convert \
Tensors in expr to the specified (toflavor) flavor of indices from \
fromflavor. Fromflavor is an optional argument with the value Automatic. \
Identity corresponds to indices with no flavor wrapper. Toflavor may be given \
the value Identity, in which case fromflavor indices are converted to \
unflavored indices.";

ClearIndexFlavor::usage="ClearIndexFlavor[flavor] will delete flavor from \
IndexFlavors and clear the associated Format definition.\n\
ClearIndexFlavor[{flavor, form}]:= ClearIndexFlavor[flavor].";

Flavor::notflavor="`` is not a currently declared index flavor.";

IndexFlavorQ::usage="IndexFlavorQ[flavor] returns True if flavor is contained \
in the IndexFlavors list and False otherwise.";



ContractKroneckers::usage="ContractKroneckers[\[Delta]][expr] will contract \
all tensors with label \[Delta], assumed to be generalized Kroneckers, to \
give a numerical factor times a Kronecker on the free indices.";

ContractKroneckers::indices="Kronecker tensor `` does not have equal up and \
down indices.";

FullKroneckerExpand::usage="FullKroneckerExpand[\[Delta]][expr] will fully \
expand tensors with label \[Delta], assumed to be generalized Kroneckers, as \
first order Kroneckers.";

FullKroneckerExpand::indices="Kronecker tensor `` does not have equal up and \
down indices.";

PartialKroneckerExpand::usage="PartialKroneckerExpand[\[Delta], order, \
suborder, expandup:True][expr] will expand tensors with label \[Delta], \
assumed to be generalized Kroneckers, and with order up and down indices, in \
terms of \[Delta]s with suborder and (order - suborder) indices. The \
expansion is done on the first suborder up indices, unless the optional 4th \
argument is set to False, in which case the first suborder down indices are \
used.";

PartialKroneckerExpand::indices="Kronecker tensor `` does not have equal up \
and down indices.";

KroneckerAbsorb::usage="KroneckerAbsorb[\[Delta]][expr] will perform all \
replacement operations of first order mixed tensors with labels \[Delta], \
assumed to be Kronecker deltas.";

PermutationPseudotensor::usage=
    "PermutationPseudotensor[n] will generate the array of values that \
correspond to the completely antisymmetric n-dimensional tensor. The \
Levi-Civita tensor may be constructed from it.";

PermutationSymbolRule::usage=
    "PermutationSymbolRule[e] will substitute values for a permutation \
pseudotensor symbol with label e. For substitution to occur the indices must \
be all up or all down, must be base indices and must all be the same flavor. \
The base indices in their declared order will have a value of 1.";



MetricSimplify::usage="MetricSimplify[g][expr] will raise, lower or replace \
indices in product terms involving g and tensors in expr using g as the label \
for a metric tensor. The metric tensor can have down, up, up/down or down/up \
indices. ";



UseCoordinates::usage="UseCoordinates[{x, y, z,...}, coord:x, \
flavor:Identity][expr] replaces the coordinate \!\(x\^i\) with the i'th \
symbol in the list everywhere in the expression. It also replaces \!\(dx\^i\) \
with d(i'th symbol) if they appear in the expression. coord is the coordinate \
label and is an optional argument with the default value x. Flavor is an \
optional argument with the default value of Identity. \n\
UseCoordinates[coord:x, flavor:Identity][expr] uses the index symbols \
established with DeclareBaseIndices.";

CoordinatesToTensors::usage="CoordinatesToTensors[coordinatelist, label:x, \
flavor:Identity] will convert coordinate Symbols to the corresponding indexed \
tensors. Label and flavor are optional arguments that designate the tensor \
label and the index flavor. The order of the symbols in the coordinates list \
must correspond to the order of the items in BaseIndices";




SymmetrizeSlots::usage=
    "SymmetrizeSlots[label, order, symmetries][expr] will put indices in \
standard order for all tensors of the given label and order in expr. The \
symmetries are given by a list of symmetry specifications, {symm1, \
symm2,...}. Each symmetry specification is of the form {-1|1,{n1,n2,...}} \
where -1 is used for antisymmetry and 1 for symmetry. n1, n2 etc., are the \
slot numbers involved in the symmetry. If there is only a single symmetry it \
may be entered without the extra brackets.";

Symmetric::usage=" Symmetric[ind][expr], calculates the symmetric tensor \
expression associated with expr for the index list ind.";

Symmetric::indices="Symmetric indices `` must be all be in the list of up, \
``, or all in the list of down, ``, indices.";

AntiSymmetric::usage=" AntiSymmetric[ind][expr], calculates the  \
antisymmetric tensor expression associated with expr for the index list ind.";

AntiSymmetric::indices="AntiSymmetric indices `` must be all be in the list \
of up, ``, or all in the list of down, ``, indices.";



DefineTensorShortcuts::usage=
    "DefineTensorShortcuts[label, order] will define tensor input shortcuts \
for all the up/down configurations for tensors with the given label and of \
the given order. The shortcuts will be designated by appending successive u's \
or d's to the tensor label in the order of the tensor slots.\n\
DefineTensorShortcuts[T, 2] will define shortcuts with names Tuu, Tud, Tdu, \
Tdd. Then, for example,\nTdu[i, j] is the same as Tensor[T, {Void, j}, {i, \
Void}].\nDefineTensorShortcuts[{u, v, w,...}, order] will define shortcuts \
for a number of labels.\nDefineTensorShortcuts[{tensor(s), order}..] can be \
used to define a number of tensors of different orders.";

ClearTensorShortcuts::usage="ClearTensorShortcuts[label, order] will clear \
all tensor input shortcuts that were established with \
DefineTensorShortcuts[label, order].\nClearTensorShortcuts[{u, v, w,...}, \
order] will clear the shortcuts for a number of labels.\n\
ClearTensorShortcuts[{tensor(s), order}..] can be used to clear a number of \
tensors of different orders.";



SetTensorValues::usage=
    "SetTensorValues[Tensor[label, up, down], values, permissive:False] will \
set the component values of the tensor. The indices can be plain or flavored \
symbols. Existing values that have differently flavored indices are retained. \
The order of storage depends upon the sort order of the symbolic indices used \
in up and down. The values are stored in UpValues[label]. Setting tensor \
values deletes any corresponding tensor value rules. If permissive is True, \
size checking of arrays is skipped.";

SetTensorValues::dim="The number of indices cannot be greater than the number \
of dimensions of values.";

SetTensorValues::size=
    "The size of each value array must be the same as NDim.";

SetTensorValueRules::usage=
    "SetTensorValueRules[Tensor[label, up, down], values, permissive:False] \
will establish rules in TensorValueRules[label] for substituting the given \
values.  The indices can be plain or flavored symbols. Existing rules that \
have differently flavored indices are retained. The order of storage depends \
upon the sort order of the symbolic indices used in up and down. Setting \
tensor values rules deletes any corresponding tensor values. If permissive is \
True, size checking of arrays is skipped.";

SetTensorValueRules::dim="The number of indices cannot be greater than the \
number of dimensions of values.";

SetTensorValueRules::size=
    "The size of each value array must be the same as NDim.";

TensorValueRules::usage="TensorValueRules[label] holds substitution value \
rules for Tensors with label.\nTensorValueRules[label1, label2,...] combines \
the substitution rules for several labels.";

ClearTensorValues::usage="ClearTensorValues[Tensor[label, upindices, \
downindices]] will clear the component values of the tensor as UpValues for \
label and also remove any corresponding substitution rules from \
TensorValueRules[label]. Existing definitions or rules that are different on \
the lhs are retained.";

NonzeroValueRules::usage="NonzeroValueRules[a, b, ...] will return the \
TensorValueRules for the labels a, b etc., which have nonzero right hand \
sides.";

DeclareZeroTensor::usage=
    "DeclareZeroTensor[label] declares that a tensor of any type with the \
given label will have zero element values when expanded to an array.";



SetMetricValues::usage="SetMetricValues[g, metricmatrix, flavor:Identity] \
creates value definitions for the metric tensor and inverse of the metric \
tensor of label g from values of metricmatrix. The optional argument flavor \
specifies the flavor with which the definitions will be stored. The default \
value is Identity, which means no flavor. The metric matrix must also be in \
the desired flavor.\n
The definitions are stored in UpValues[g]";

SetMetricValueRules::usage="SetMetricValueRules[g, metricmatrix, \
flavor:Identity] creates a list of rules for the metric tensor and inverse of \
the metric tensor of label g from values of metricmatrix. The optional \
argument flavor specifies the flavor with which the rules will be stored. The \
default value is Identity, which means no flavor. The metric matrix must also \
be in the desired flavor.\n
To see, the created rules, evaluate: TensorValueRules[g]";

CalculateChristoffelu::usage=
    "CalculateChristoffelu[xu[i], metricmatrix, simplification:Identity], \
calculates the array corresponding to the Christoffel symbols \
(\[CapitalGamma]udd[i,j,k]), from the values of metricmatrix and the x vector \
pattern.  The flavor is extracted from the flavor of i. Metricmatrix must \
also be in the desired flavor. simplification is an optional argument that \
supplies a simplification routine to be used on the Christoffel elements.";

CalculateChristoffeld::usage=
    "CalculateChristoffelu[xu[i], metricmatrix, simplification:Identity], \
calculates the array corresponding to the Christoffel symbols \
(\[CapitalGamma]ddd[i,j,k]), from the values of metricmatrix and the x vector \
pattern.  The flavor is extracted from the flavor of i. Metricmatrix must \
also be in the desired flavor. simplification is an optional argument that \
supplies a simplification routine to be used on the Christoffel elements.";

SetChristoffelValueRules::usage="SetChristoffelValueRules[xu[i], \
metricmatrix, \[CapitalGamma], simplification:Identity], creates a list of \
rules for the Christoffel symbols: \[CapitalGamma]udd[s, m, n] and \
\[CapitalGamma]ddd[s, m, n] from the values metricmatrix in coordinates of \
xu[i]. The flavor is extracted from the flavor of i. Metricmatrix must also \
be in the desired flavor. The rules are stored in TensorValueRules[\
\[CapitalGamma]] simplification is an optional argument that supplies a \
simplification routine to be used on the Christoffel elements."

SetChristoffelValues::usage="SetChristoffelValueRules[xu[i], metricmatrix, \
\[CapitalGamma], simplification:Identity], creates a set of definitions for \
the Christoffel symbols: \[CapitalGamma]udd[s, m, n] and \
\[CapitalGamma]ddd[s, m, n] from the values metricmatrix in coordinates of \
xu[i]. The flavor is extracted from the flavor of i. Metricmatrix must also \
be in the desired flavor. The definitions are stored in UpValues[\
\[CapitalGamma]] simplification is an optional argument that supplies a \
simplification routine to be used on the Christoffel elements."



PartialD::usage=
    "PartialD[tensor, i]  calculates the partial derivative of the tensor \
with respect to the coordinate of index i. \n PartialD[tensor, {i,j,...}] \
represents the covariant derivative with repect to the list of indicest\n An \
index with a comma as prefix represents the partial derivative over the \
respective index. \n
This is ambiguous until we expand the partial derivative providing the \
specific coordinates using ExpandPartialD. The derivative in this shape does \
can not calculate partial derivatives of components of tensors because the \
coordinates and the kronecker tensor are not yet specified. Symbols are \
considered constants when PartialD is used in this shape.\n
PartialD[{x,\[Delta],g,\[CapitalGamma]}][ tensor , Tensor[x,{i},{Void}] ] \
calculates the partial derivative respect to the i-coordinate using \
coordinate label x and kronecker tensor label \[Delta].\n
PartialD[{x,\[Delta],g,\[CapitalGamma]}][ tensor , {Tensor[x,{i},{Void}]..} ] \
calculates the higher order partial derivative over the coordinates. Symbols \
are not considered constants when the derivative is carried out over \
coordinates in this shape of the partial derivative (with labels)\n
PartialD[{x,\[Delta],g,\[CapitalGamma]}][ expr , v ] is the partial \
derivative of expr respect to the symbol v. When expr is free from tensor \
objects PartialD is reduced to the standard Mathematica partial derivative \
function D.\n
EvaluatePartialD is needed to fully evaluate the partial derivative, when the \
expression is completely expanded with the indices explicitly members of the \
global list BaseIndices. ";

ExpandPartialD::usage=
    "ExpandPartialD[{x,\[Delta],g,\[CapitalGamma]}][ expr ], expands the \
partial derivative involved in expr using coordinates label x and kronecker \
tensor \[Delta].";

NondependentPartialD::usage=
    "NondependentPartialD[{lab1, lab2,...}..][expr] will implement the \
assumption that Tensor labels, {lab1, lab2,...} are nondependent so that a \
partial derivative of one with respect to another will be zero. Multiple \
lists of nondependent tensor labels may be provided";



CovariantD::usage=
    "CovariantD[tensor, i] represents the covariant derivative of the tensor \
with respect to the index i.\nCovariantD[tensor, {i,j,...}] represents the \
covariant derivative with repect to the list of indices. \n Symbols are \
considered constans.";

ExpandCovariantD::usage="ExpandCovariantD[{x,\[Delta],g,\[CapitalGamma]},a][\
expr] will expand a covariant tensors using coordinates x, metric tensor g, \
Christoffel Symbol \[CapitalGamma] and the dummy index a.\n
ExpandCovariantD[{x,\[Delta],g,\[CapitalGamma]},{a,b,...}][expr] will expand \
covariant derivatives of higher order using {a,b,...} as dummy indices.\n
"



TotalD::usage=
    "TotalD[ expr, t]  calculates the total derivative of expr with respect \
to the parameter t. Symbols are not considered constants unless they have the \
Constant attribute.\n 
TotalD[ expr, {t,v,...}] represents the covariant derivative with repect to \
the list of parameters \n 
This derivative can be we expanded in terms of its the partial derivative \
over the coordinates using ExpandTotalD.\n
TotalD is reduced to the standard Mathematica Dt if expr is free from tensor \
objects.
";

ExpandTotalD::usage=
  "ExpandTotalD[{x,\[Delta],g,\[CapitalGamma]},a][ tensor ], expands the \
total derivative with coordinates label x and kronecker tensor \[Delta] using \
the dummy index a\n
  
  ExpandTotalD[{x,\[Delta],g,\[CapitalGamma]},{a,b,...}][ tensor ], expands \
the total derivatives of higher order with coordinates label x and kronecker \
tensor \[Delta] using the dummy indices a, b, ..."



AbsoluteD::usage="AbsoluteD[tensor, t]  represents the absolute derivative of \
the tensor with respect to the parameter t. \nAbsoluteD[tensor, {t,v,...}] \
represents the absolute derivative with repect to the list of parameters \n\
This derivative is ambiguous until we expand the partial derivative providing \
the specific coordinates using ExpandAbsoluteD."


ExpandAbsoluteD::usage="ExpandAbsoluteD[{x,\[Delta],g,\[CapitalGamma]},{a,b}][\
expr] will expand a first order absolute derivative of tensors using \
coordinates x, Kronecker \[Delta], metric tensor g, Christoffel symbol \
\[CapitalGamma] and the dummy indices a and b.\n\
ExpandAbsoluteD[{x,\[Delta],g,\[CapitalGamma]},{{a,b}, {c,d},...}][expr] will \
expand higher order absolute derivatives. \nTwo dummmy indices are needed for \
each order of expansion."



LieD::usage="LieD[tensor, V]  represents the Lie derivative of the tensor \
with respect to the vector field V.\nLieD[tensor, {U,V...}] represents the \
Lie derivative with repect to the list of vector fields.\nThis derivative is \
ambiguous until we expand the partial derivatives, providing the specific \
coordinates using ExpandLieD."

ExpandLieD::usage="ExpandLieD[{x,\[Delta],g,\[CapitalGamma]}, a][expr] will \
expand a first order Lie derivative of expr using coordinates x, Kronecker \
\[Delta] and dummy index a.\nExpandLieD[{x,\[Delta],g,\[CapitalGamma]}, \
{a,b,...}][expr] will expand higher order Lie derivatives using the list \
{a,b,..} as dummy indices."



FreeTensorQ::usage="FreeTensorQ[ expr ], gives True or False if expr contains \
a Tensor "

FreeCovQ::usage="FreeCovQ[ expr ], gives True or False if expr contains a \
covariant derivative "

FreeTotalDQ::usage="FreeTotalDQ[ expr ], gives True or False if expr contains \
a total derivative "



Begin["`Private`"]



VoidString = " ";
$PrePrint=StyleForm[##,FontSize\[Rule]16,FontFamily\[Rule]"Courier"]&;

IndexFlavors={};



PVector=TCliffordAlgebra1`TClifford`PVector;



SetDerivativeSymbols[
    list:{_String,_String,_String,_String,_String,_String,_String}]:=
  Module[{},
    {DifSym,CovSym,TDu,TDd,ADu,ADd,LDSym}=list;
    If[LDSym==="",
      If[Length[FormatValues[LieD]]>0,Format[LieD[T_,V__]]=.],
      Format[LieD[T_,V__]]:=DisplayForm[RowBox[{LDSym,"[",T,",",V,"]"}]]]]



Format[ Tensor[A_] ]:= A;

Format[ Tensor[A_,up_List,down_List] ]:=
    Module[{newdown=down,newup=up,makespace},
      makespace=If[#1===Void,StyleForm[#2,ShowContents\[Rule]False],#1]&;
      newup=Inner[makespace,newup,newdown,List];
      newdown=Inner[makespace,newdown,newup,List];
      Subsuperscript[A,SequenceForm@@newdown,SequenceForm@@newup]
      ];



Unprotect[Power];
Format[Power[
        a_/;\[Not]FreeQ[{Head[a]},Tensor|PartialD|TotalD|AbsoluteD|HoldForm],
        power_],TraditionalForm]:=
    DisplayForm[
      SuperscriptBox[RowBox[{"(",ToBoxes[a,TraditionalForm],")"}],power]];
Format[Power[
        a_/;\[Not]FreeQ[{Head[a]},Tensor|PartialD|TotalD|AbsoluteD|HoldForm],
        power_]]:=
    DisplayForm[SuperscriptBox[RowBox[{"(",ToBoxes[a],")"}],power]];
Protect[Power];



Format[Dif[index_]]:=SequenceForm[DifSym,index]

Format[Cov[index_]]:=SequenceForm[CovSym,index]



Format[ PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][ w_ , Tx_List]  ] := 
    Module[{HF,dummy},
       Format[HF[p_,q__]]:=HoldForm[D[p,q]];
      HF[w,Sequence@@Tx]               
      ];

Format[ PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][ w_ ,Tx_   ]  ] :=
   Module[{},
      HoldForm[ D[w,Tx ] ]             
      ]/;Not[VectorQ[Tx]]



Format[TotalD[T_,t_]]:=
    Module[{st={t}},
        SequenceForm[TDu,
            T]/(SequenceForm@@MapThread[SequenceForm[TDd,#]&,{st}])
        ]/;Not[VectorQ[T]];

Format[TotalD[T_,{t__}]]:=
  Module[{n=Length[{t}],st=Sort[{t}]},
    SequenceForm[If[n\[Equal]1,TDu,Superscript[TDu,n]],
        T]/(SequenceForm@@MapThread[SequenceForm[TDd,#]&,{st}])
    ]

Format[TotalD[T_]]:=
  Module[{},
      DisplayForm[RowBox[{TDu,T}]]]/;Not[VectorQ[T]]



Format[AbsoluteD[T_,t_]]:=
    Module[{st={t}},
        SequenceForm[ADu,
            T]/(SequenceForm@@MapThread[SequenceForm[ADd,#]&,{st}])
        ]/;Not[VectorQ[T]];

Format[AbsoluteD[T_,{t__}]]:=
  Module[{n=Length[{t}],st=Sort[{t}]},
    SequenceForm[If[n\[Equal]1,ADu,Superscript[ADu,n]],
        T]/(SequenceForm@@MapThread[SequenceForm[ADd,#]&,{st}])
    ]



ToArrayValues[][expr_]:=ToArrayValues[BaseIndices][expr]

ToArrayValues[baseindices_List][expr_]:=
  Module[{work,labels,valuerules,subroutine},
    subroutine[
        work_]:=(labels=
          Cases[work,Tensor[label_,___]\[Rule]label,{0,\[Infinity]}];
        valuerules=TensorValueRules@@labels;
        If[Head[valuerules]===List,work/.valuerules,work]);
    
    work=expr//EinsteinSum[baseindices]//EinsteinArray[baseindices];
    
    FixedPoint[subroutine,work,5]
    ]

ContractArray[tt_,inxs:({_,_}..)]:=Nest[Tr[#1,Plus,2]&,Transpose[tt,
      (* Calculate the destination slots of each level *)
      Block[{x=Range[TensorRank[tt]],cindices=Join[inxs]},
        x\[LeftDoubleBracket]Join[cindices,
              Complement[x,cindices]]\[RightDoubleBracket]=x;
        x]],
    Length[{inxs}]]



DeclareBaseIndices[
    indexlist:{(_Integer|_Symbol)..}]:= (BaseIndices=indexlist; 
    NDim=Length[BaseIndices];)

BaseIndexQ[index_]:=
  MemberQ[BaseIndices, RawIndex[index]]



LinearBreakout[f__][vars__][expr_]:=
  expr//.{(g:Alternatives@@{f})[p1___,a_+b__,p2___]\[RuleDelayed]
        g[p1,a,p2]+g[p1,Plus[b],p2],(g:Alternatives@@{f})[p1___,
          a_ b:Alternatives@@{vars},p2___]\[RuleDelayed]a g[p1,b,p2]}

PushOnto[argslist_List,ontolist_List][expr_]:=
  Module[{onto=Alternatives@@ontolist},
    expr/.(h_/;\[Not]FreeQ[h,onto])@@
          argslist\[RuleDelayed](h/.a_/;MatchQ[a,onto]\[Rule]a@@argslist)
    ]

PushOnto[ontolist_List][(head_)[arglist___]]:=
  Module[{onto=Alternatives@@ontolist},
    head/.a_/;MatchQ[a,onto]\[RuleDelayed]a[arglist]
    ]

CircleEvalRule=
  {CircleTimes[vects__][args__]/;Length[{vects}]==Length[{args}]\[RuleDelayed]
      Module[{scalar,tensor,a},
        scalar=
          Times@@Select[MapThread[Dot,{{vects},{args}}], FreeQ[#,Null]&];
        If[FreeQ[{args},Null],
          tensor=1,
          
          tensor=CircleTimes@@
              First@Transpose@
                  Select[Transpose[{{vects},{args}}],#\[LeftDoubleBracket]2\
\[RightDoubleBracket]==Null&];
          tensor=tensor/.CircleTimes[a_]\[Rule]a];
        scalar tensor],
    (v:Tensor[_,{_},{_}])[arg_]\[RuleDelayed]v.arg};

EvaluateSlots[b_Symbol,g_Symbol][expr_]:=
  Module[{bu,bd,work},
    {bu,bd}=Symbol[SymbolName[b]<>#]&/@{"u","d"};
    work=(expr/.head_?(\[Not]FreeQ[#,CircleTimes]&)[
                args___]\[RuleDelayed](ExpandAll[head[args]]//
                  PushOnto[{args},{CircleTimes[__]}])/.CircleEvalRule);
    work=(work//LinearBreakout[Dot][bu[_],bd[_]])/.BasisDotProductRules[b,g];
    work=work//MetricSimplify[g];
    work/.CircleTimes[x_]\[Rule]x
    ];

BasisDotProductRules[b_Symbol,
    g_Symbol]:={Tensor[b,{i_},{Void}].Tensor[b,{j_},{Void}]\[Rule]
      Tensor[g,{i,j},{Void,Void}],
    Tensor[b,{Void},{i_}].Tensor[b,{Void},{j_}]\[Rule]
      Tensor[g,{Void,Void},{i,j}],
    Tensor[b,{i_},{Void}].Tensor[b,{Void},{j_}]\[Rule]
      Tensor[g,{i,Void},{Void,j}],
    Tensor[b,{Void},{i_}].Tensor[b,{j_},{Void}]\[Rule]
      Tensor[g,{Void,j},{i,Void}]}

ReverseBasisDotProductRules[b_Symbol,
    g_Symbol]:={Tensor[g,{i_,j_},{Void,Void}]\[Rule]
      Tensor[b,{i},{Void}].Tensor[b,{j},{Void}],
    Tensor[g,{Void,Void},{i_,j_}]\[Rule]
      Tensor[b,{Void},{i}].Tensor[b,{Void},{j}],
    Tensor[g,{i_,Void},{Void,j_}]\[Rule]
      Tensor[b,{i},{Void}].Tensor[b,{Void},{j}],
    Tensor[g,{Void,j_},{i_,Void}]\[Rule]
      Tensor[b,{Void},{i}].Tensor[b,{j},{Void}]};

EvaluateDotProducts[e_,g_,metricsimplify_:True][expr_]:=
  expr/.
    {Dot[0,_]\[Rule]0,
      Dot[_,0]\[Rule]0,
      dp:Dot[_,_]\[RuleDelayed]((dp//
                  LinearBreakout[Dot][Tensor[e,{_},{Void}],
                    Tensor[e,{Void},{_}]])/.BasisDotProductRules[ e,g]//
            If[metricsimplify,MetricSimplify[g],Identity])}

ConstructDirectProduct[a_. b:CircleTimes[__]]:=
  Module[{work,heads,newhead,arglist},
    work=List@@b;
    heads=Head/@work;
    arglist=Replace[#,f_[args__]\[Rule]args]&/@work;
    newhead=CircleTimes@@heads;
    newhead=newhead//LinearBreakout[CircleTimes][CircleTimes[__]];
    newhead=newhead/.expr:CircleTimes[__]\[RuleDelayed]Flatten[expr];
    a (newhead@@arglist)]

GenerateBasisTensors[g_Symbol,configuration_String]:=
  Module[{configs,indices,basistensor},
    configs=Characters[configuration];
    If[\[Not]And@@((#==="d")\[Or](#==="u")&/@configs),
      Message[GenerateBasisTensors::config,configuration];Abort[]];
    indices=Table[Unique["i"],{Length[configs]}];
    basistensor=
      CircleTimes@@MapThread[Symbol[ToString[g]<>#1][#2]&,{configs,indices}];
    basistensor//ArrayExpansion[indices]//Flatten
    ]

UsePartialDChainRule[coordtensor_][expr_]:=
  expr/.HoldPattern[PartialD[labs_][x_Tensor,y_]]\[Rule]
      PartialD[labs][x,coordtensor]PartialD[labs][coordtensor,y]

UsePartialDChainRule[diffvar1_,diffvar2_][expr_]:=
  expr/.{HoldPattern[PartialD[labs_][x_Tensor,diffvar2]]\[Rule]
        PartialD[labs][x,diffvar1]PartialD[labs][diffvar1,diffvar2],
      HoldPattern[
          PartialD[labs_][x_Tensor,{varsa___,diffvar2,varsb___}]]\[Rule]
        PartialD[labs][x,{varsa,diffvar1,varsb}]PartialD[labs][diffvar1,
            diffvar2]}

UseTotalDChainRule[coordtensor_,labels_][expr_]:=
  expr/.HoldPattern[TotalD[x_,y_]]\[Rule]
      PartialD[labels][x,coordtensor]TotalD[coordtensor,y]





UnsortedUnion[x_]:=Module[{f},f[y_]:=(f[y]=Sequence[];y);f/@x]



ParseTermIndices[term_]:=
  Module[{wterm=term,upindices,downindices,freeup,freedown,dummyindices,
      allindices,badindices,i,Dummy,dpositions,maxlength},
    
    wterm=
      wterm/.Dot[a_,b_?FreeTensorQ]\[Rule]a/.Dot[a_?FreeTensorQ,b_]\[Rule]b;
    
    wterm=
      wterm/.Dot\[Rule]Times/.Cross\[Rule]Times/.CircleTimes\[Rule]
            Times/.Times\[Rule]List;
    wterm=wterm/.Power[a_,n_]\[RuleDelayed]Table[a,{n}];
    wterm=Flatten[{wterm}];
    
    wterm=(Replace[#,
              {HoldPattern[(TotalD|AbsoluteD|LieD)[
                      tensor_/;Length[tensor]>1,___]]\[Rule]tensor,
                
                HoldPattern[(TotalD|AbsoluteD|LieD)[
                      tensor_/;Length[tensor]\[LessEqual]1,___]]\[Rule]
                  Sequence[],
                t_/;FreeQ[t,(Tensor|TotalD|PartialD)]\[Rule]Sequence[],
                
                t_/;\[Not]MatchQ[Head[t],Tensor|PartialD[_]|TotalD]\[Rule]
                  Sequence[],
                Tensor[_]\[Rule]Sequence[]}])&/@wterm;
    
    If[wterm==={},Return[{{},{{},{}},{}}]];
    
    (* Extract up and down indices *)
    wterm=(#/.
              {Tensor[_,up_,down_]\[Rule]{up,down},
                
                
                HoldPattern[
                    PartialD[_][_Symbol,
                      Tensor[_,up2_,down2_]]]\[RuleDelayed]{Flatten[{down2}],
                    Flatten[{up2}]},
                
                
                HoldPattern[
                    PartialD[_][Tensor[_,up1_,down1_],
                      Tensor[_,up2_,down2_]]]\[RuleDelayed]{Flatten[{up1,
                        down2}],Flatten[{up2,down1}]},
                
                
                HoldPattern[
                    PartialD[_][Tensor[_],
                      Tensor[_,up2_,down2_]]]\[RuleDelayed]{down2,up2},
                
                
                HoldPattern[
                    PartialD[_][Tensor[_,up_,down1_],
                      v_Symbol]]\[RuleDelayed]{up,down1},
                
                
                HoldPattern[
                    PartialD[_][Tensor[_],v_Symbol]]\[RuleDelayed]{{},{}},
                
                
                HoldPattern[
                    PartialD[_][Tensor[_,up1_,down1_],
                      diflist_?VectorQ]]\[RuleDelayed]
                  Module[{up2,down2},
                    up2=Cases[diflist,Tensor[_,up_,_]\[Rule]up]//Flatten;
                    down2=
                      Cases[diflist,Tensor[_,_,down_]\[Rule]down]//Flatten;
                    {Flatten[{up1,down2}],Flatten[{down1,up2}]}],
                
                
                HoldPattern[
                    PartialD[_][Tensor[_]|_Symbol,
                      diflist_?VectorQ]]\[RuleDelayed]
                  Module[{up2,down2},
                    up2=Cases[diflist,Tensor[_,up_,_]\[Rule]up]//Flatten;
                    
                    down2=Cases[diflist,Tensor[_,_,down_]\[Rule]down]//
                        Flatten;
                    {down2,up2}]})&/@wterm;
    
    wterm=
      wterm/.Void\[Rule]Sequence[]/.Dif[index_]\[Rule]index/.Cov[
            index_]\[Rule]index;
    
    wterm=Transpose[wterm];
    {upindices,downindices}=Join@@#&/@wterm;
    upindices=(#/._?BaseIndexQ\[Rule]Sequence[])&/@upindices;
    downindices=(#/._?BaseIndexQ\[Rule]Sequence[])&/@downindices;
    
    allindices=UnsortedUnion[Join[upindices,downindices]];
    dummyindices=
      Select[allindices,(Count[upindices, #]\[Equal]1)\[And](Count[
                  downindices, #]\[Equal]1)&];
    (* Sort the dummy indices by the order of their first occurrence in the \
term *)
    dpositions=First[Position[term, #,\[Infinity],1]]&/@dummyindices;
    maxlength=Max[Length/@dpositions];
    dpositions=PadRight[#,maxlength]&/@dpositions;
    dpositions=Sort[Flatten/@Transpose[{dpositions,dummyindices}]];
    dummyindices=Last/@dpositions;
    freeindices=
      Select[allindices,(Count[upindices, #]+
                Count[downindices, #])\[Equal]1&];
    badindices=Complement[allindices,freeindices,dummyindices];
    freeup=Cases[upindices,Alternatives@@freeindices];
    freedown=Cases[downindices,Alternatives@@freeindices];
    {dummyindices,{freeup,freedown},badindices}
    ]

RawIndex[index_]:=
  Switch[index,
    Cov[_]|Dif[_],RawIndex[First[index]],
    (f_?IndexFlavorQ)[_],First[index],
    _Symbol|_Integer,index,
    _,Message[RawIndex::notindex,index];index]

ExtractFreeIndices[expr_]:=
  Module[{terms,updowns,matched,badindices,nobadindices},
    terms=Flatten[{Expand[expr]/.Equal\[Rule]List/.Plus\[Rule]List}];
    terms=ParseTermIndices/@terms;
    terms=Transpose[terms];
    badindices=Take[terms,-1];
    terms=Part[terms,2];
    terms=MapAt[Sort,#,{{1},{2}}]&/@terms;
    updowns=First[terms];
    nobadindices=Length[Flatten[badindices]]\[Equal]0;
    matched=And@@(updowns===#&/@terms);
    If[nobadindices\[And]matched,updowns,Message[FreeIndices::notmatched];
      False]
    ]

SymbolicIndexQ[i_]:=
  Module[{ISymbol},
    ISymbol[s_]:=Head[s]===Symbol\[And]\[Not]BaseIndexQ[s];
    MatchQ[i,( _?ISymbol)|((_?IndexFlavorQ)[_?ISymbol])]
    ]



\!\(jval[i_, j_, array_, 
      pos_] := \[IndentingNewLine]Module[{jnew, 
        newpos}, \[IndentingNewLine]newpos = 
        First[pos]; \[IndentingNewLine]jnew = 
        If[Length[newpos] \[Equal] 1, j, 
          array\_\(\(\[LeftDoubleBracket]\)\(First[newpos]\)\(\
\[RightDoubleBracket]\)\) /. i \[Rule] j]; \[IndentingNewLine]{jnew, 
        First[newpos]}]\)

\!\(\(RaiseIndex[i_, j_]\)[
      t_Tensor] := \[IndentingNewLine]Module[{pos, ups, downs, 
        jnew}, \[IndentingNewLine]{ups, downs} = 
        List @@ t\_\(\(\[LeftDoubleBracket]\)\({2, \
3}\)\(\[RightDoubleBracket]\)\); \[IndentingNewLine]pos = 
        Position[downs, i]; \[IndentingNewLine]If[pos === {}, 
        Message[RaiseIndex::noindex, i, t]; 
        Abort[]]; \[IndentingNewLine]{jnew, pos} = 
        jval[i, j, downs, 
          pos]; \[IndentingNewLine]downs\_\(\(\[LeftDoubleBracket]\)\(pos\)\(\
\[RightDoubleBracket]\)\) = 
        Void; \[IndentingNewLine]ups\_\(\(\[LeftDoubleBracket]\)\(pos\)\(\
\[RightDoubleBracket]\)\) = jnew; \[IndentingNewLine]Tensor[First[t], ups, 
        downs]\[IndentingNewLine]]\)

\!\(\(LowerIndex[i_, j_]\)[
      t_Tensor] := \[IndentingNewLine]Module[{pos, ups, downs, 
        jnew}, \[IndentingNewLine]{ups, downs} = 
        List @@ t\_\(\(\[LeftDoubleBracket]\)\({2, \
3}\)\(\[RightDoubleBracket]\)\); \[IndentingNewLine]pos = 
        Position[ups, i]; \[IndentingNewLine]If[pos === {}, 
        Message[LowerIndex::noindex, i, t]; 
        Abort[]]; \[IndentingNewLine]{jnew, pos} = 
        jval[i, j, ups, 
          pos]; \[IndentingNewLine]ups\_\(\(\[LeftDoubleBracket]\)\(pos\)\(\
\[RightDoubleBracket]\)\) = 
        Void; \[IndentingNewLine]downs\_\(\(\[LeftDoubleBracket]\)\(pos\)\(\
\[RightDoubleBracket]\)\) = jnew; \[IndentingNewLine]Tensor[First[t], ups, 
        downs]\[IndentingNewLine]]\)

\!\(\(ReplaceIndex::noindex = "\<`` is not an index in ``\>";\)\n
  \(ReplaceIndex[i_, j_]\)[
      t_Tensor] := \[IndentingNewLine]Module[{ups, downs, posups, posdowns, 
        jnew}, \[IndentingNewLine]{ups, downs} = 
        List @@ t\_\(\(\[LeftDoubleBracket]\)\({2, \
3}\)\(\[RightDoubleBracket]\)\); \[IndentingNewLine]posups = 
        Position[ups, i]; \[IndentingNewLine]posdowns = 
        Position[downs, i]; \[IndentingNewLine]If[
        posups === {} \[And] posdowns === {}, 
        Message[ReplaceIndex::noindex, i, t]; Abort[]]; \[IndentingNewLine]If[
        posups =!= {}, {jnew, pos} = 
          jval[i, j, ups, 
            posups]; \
\[IndentingNewLine]ups\_\(\(\[LeftDoubleBracket]\)\(pos\)\(\
\[RightDoubleBracket]\)\) = jnew;]; \[IndentingNewLine]If[
        posdowns =!= {}, {jnew, pos} = 
          jval[i, j, downs, 
            posdowns]; \
\[IndentingNewLine]downs\_\(\(\[LeftDoubleBracket]\)\(pos\)\(\
\[RightDoubleBracket]\)\) = jnew;]; \[IndentingNewLine]Tensor[First[t], ups, 
        downs]\[IndentingNewLine]]\)

IndexChange[pair:{_?SymbolicIndexQ,_?SymbolicIndexQ},sign_:1][term_]:=
  sign term/.Rule@@pair

IndexChange[{pairs:{_,_}..},sign_:1][term_]:=
  sign term/.Rule@@@{pairs}



\!\(tensorindexpositions[expr_, 
      indx_] := \[IndentingNewLine]Module[{a, p, pos1, pos2, ppos1, ppos2, 
        work}, \[IndentingNewLine]pos1 = 
        Position[expr, 
          Tensor[_, 
              a__] /; \[Not] FreeQ[{a}, 
                indx]]; \[IndentingNewLine]ppos1 = \(p @@ # &\) /@ 
          pos1; \[IndentingNewLine]pos2 = 
        Position[expr, indx]; \[IndentingNewLine]ppos2 = \(p @@ # &\) /@ 
          pos2; \[IndentingNewLine]work = 
        Outer[{#1, #2} &, ppos1, ppos2] /. 
          p \[Rule] List; \[IndentingNewLine]work = 
        Flatten[work, 1]; \[IndentingNewLine]Select[
        work, #\_\(\(\[LeftDoubleBracket]\)\(1\)\(\[RightDoubleBracket]\)\) === 
            Take[#\_\(\(\[LeftDoubleBracket]\)\(2\)\(\[RightDoubleBracket]\)\)\
, Length[#\_\(\(\[LeftDoubleBracket]\)\(1\)\(\[RightDoubleBracket]\)\)]] &]\
\[IndentingNewLine]]\)

UpDownSwap[indx_][expr_]:=
  Module[{q1=Unique[q],q2=Unique[q],pos,wexpr,swap},
    
    swap[i_,pos_,j_][wexpr_]:=
      Module[{updown},
        updown=Part[Last[pos],Length[First[pos]]+1];
        Switch[updown,
          2,LowerIndex[i,j][Part[wexpr,Sequence@@First[pos]]],
          3,RaiseIndex[i,j][Part[wexpr,Sequence@@First[pos]]]]
        ];
    
    Switch[Head[expr],
      _List,UpDownSwap[indx]/@expr,
      _Equal,UpDownSwap[indx]/@expr,
      _Plus,UpDownSwap[indx]/@expr,
      _,
      If[\[Not]MemberQ[First[ParseTermIndices[expr]], indx],
        Message[UpDownSwap::index,indx,expr];Abort[]];
      wexpr=Hold@@{expr};
      pos=tensorindexpositions[wexpr,indx];
      wexpr=ReplacePart[wexpr,q1,Last[First[pos]]];
      wexpr=ReplacePart[wexpr,q2,Last[Last[pos]]];
      
      wexpr=
        ReplacePart[wexpr,swap[q1,First[pos],indx][wexpr],First[First[pos]]];
      wexpr=
        ReplacePart[wexpr,swap[q2,Last[pos],indx][wexpr],First[Last[pos]]];
      ];
    First[wexpr]
    ]



DoubleVoidRule = 
  Tensor[P_,{subP__},{supP1___,Void,supP2___}] -> 
    Tensor[P,{subP},{supP1,fXX[Void],supP2}] ;

DoubleIndexSimplifyRule01=	
a_.*Tensor[A_,{subA__},{supA1___,i_,supA2___}]*
        Tensor[B_,{subB1___,i_,subB2___},{supB___}] +
b_.*Tensor[A_,{subAA__},{supAA1___,j_,supAA2___}]*
        Tensor[B_,{subBB1___,j_,subBB2___},{supBB___}] :> 
a*Tensor[A,{subA},{supA1,i,supA2}]  Tensor[B,{subB1,i,subB2},{supB}]+
b*Tensor[A,{subAA},{supAA1,fXX[i],supAA2} ]*
          Tensor[B,{subBB1,i,subBB2},{supBB}] /;
      FreeQ[{supAA1,supAA2,subBB1,subBB2},i]

DoubleIndexSimplifyRule02 =
a_.*Tensor[ A_,{subA1___,i_,subA2___},{supA1___,i_,supA2___}] + 
b_.*Tensor[ A_,{subAA1___,k_,subAA2___},{supAA1___,k_,supAA2___}]	:>
a*Tensor[ A,{subA1,i,subA2},{supA1,i,supA2}]+ 
b*Tensor[ A,{subAA1,fXX[i],subAA2},{supAA1,i,supAA2}]/;
      Length[{subA2}]===Length[{subAA2}];

DoubleIndexSimplifyRule03=	
a_. Tensor[A_,{subA__},{supA1___,i_,supA2___}]*
        Tensor[B_,{subB1___,i_,subB2___},{supB___}]+
b_. Tensor[A_,{subAA__},{supAA1___,j_,supAA2___}]*
        Tensor[B_,{subBB1___,j_,subBB2___},{supBB___}]* 
Tensor[P_,{subP__},{supP1___,i_,supP2___}]*
        Tensor[Q_,{subQ1___,i_,subQ2___},{supQ___}] :> 
a*Tensor[A,{subA},{supA1,i,supA2}]  Tensor[B,{subB1,i,subB2},{supB}] +
b*Tensor[A,{subAA},{supAA1,fXX[i],supAA2} ]*
        Tensor[B,{subBB1,i,subBB2},{supBB}]*
        Tensor[P,{subP},{supP1,j,supP2}]*  
Tensor[Q,{subQ1,j,subQ2},{supQ}] ;

DoubleIndexSimplifyRule04 =
a_.*Tensor[ A_,{subA1___,i_,subA2___},{supA1___,i_,supA2___}]+ 
b_.* Tensor[ A_,{subAA1___,k_,subAA2___},{supAA1___,k_,supAA2___}]*
        Tensor[P_,{subP__},{supP1___,i_,supP2___}]*  
Tensor[Q_,{subQ1___,i_,subQ2___},{supQ___}]  :> 
    a*Tensor[ A,{subA1,i,subA2},{supA1,i,supA2}]+ 
b*Tensor[ A,{subAA1,fXX[i],subAA2},{supAA1,i,supAA2}]* 
          Tensor[P,{subP},{supP1,k ,supP2}]*  
Tensor[Q,{subQ1,k,subQ2},{supQ}]/;Length[{subA2}]===Length[{subAA2}];	

DoubleIndexSimplifyRule05 =	{
a_.*Tensor[A_,{subA1___,i_,subA2___,j_,subA3___},{supA__}]*
Tensor[B_,{subB__},{supB1___,i_,supB2___}]*
Tensor[C_,{subC__},{supC1___,j_,supC2___}]  +
b_.*Tensor[A_,{subAA1___,j_,subAA2___,i_,subAA3___},{supA__}]*
Tensor[B_,{subB__},{supBB1___,i_,supBB2___}]*
Tensor[C_,{subC__},{supCC1___,j_,supCC2___}]:>
a*Tensor[A,{subA1,i,subA2,j,subA3},{supA}]*
Tensor[B,{subB},{supB1,i,supB2}]*Tensor[C,{subC},{supC1,j,supC2}]  +
b*Tensor[A,{subAA1,i,subAA2,j,subAA3},{supA}]*
Tensor[B,{subB},{supBB1,j,supBB2}]*Tensor[C,{subC},{supCC1,i,supCC2}]
,
a_.*Tensor[A_,{subA__},{supA1___,i_,supA2___,j_,supA3___}]*
Tensor[B_,{subB1___,i_,subB2___},{supB__}]*
Tensor[C_,{subC1___,j_,subC2___},{supC__}]  +
b_.*Tensor[A_,{subA__},{supAA1___,j_,supAA2___,i_,supAA3___}]*
Tensor[B_,{subBB1___,i_,subBB2___},{supB__}]*
Tensor[C_,{subCC1___,j_,subCC2___},{supC__}]   :>
a*Tensor[A,{subA},{supA1,i,supA2,j,supA3}]*
Tensor[B,{subB1,i,subB2},{supB}]*
Tensor[C,{subC1,j,subC2},{supC}]  +
b*Tensor[A,{subA},{supAA1,i,supAA2,j,supAA3}]*
Tensor[B,{subBB1,j,subBB2},{supB}]*
Tensor[C,{subCC1,i,subCC2},{supC}]
};
        

DummySimplify[w_]:=Module[{},
Expand[w]//.DoubleVoidRule//.DoubleIndexSimplifyRule04//.
DoubleIndexSimplifyRule02//.DoubleIndexSimplifyRule03//.\
DoubleIndexSimplifyRule01/.fXX[xx_]\[Rule]xx]//.DoubleIndexSimplifyRule05;



SimplifyTensorSum[sum_]/;MemberQ[(Times|Plus),Head[sum]]:=
  Module[{wsum,termindices,dummies,containsbadterms,i,termdummies,rule},
    wsum=Expand[sum];
    wsum=If[Head[wsum]===Plus,List@@wsum,{wsum}];
    termindices=ParseTermIndices/@wsum;
    containsbadterms=False;
    Do[If[termindices\[LeftDoubleBracket]i,3\[RightDoubleBracket]=!={},
        containsbadterms=True;
        Message[SimplifyTensorSum::badterm,
          wsum\[LeftDoubleBracket]i\[RightDoubleBracket]]],{i,1,
        Length[wsum]}];
    If[containsbadterms,Abort[]];
    If[\[Not](SameQ@@
            Table[Sort/@
                termindices\[LeftDoubleBracket]i,2\[RightDoubleBracket],{i,1,
                Length[wsum]}]),Message[SimplifyTensorSum::free];Abort[]];
    dummies=
      UnsortedUnion[
        Join@@Table[
            termindices\[LeftDoubleBracket]i,1\[RightDoubleBracket],{i,1,
              Length[wsum]}]];
    Do[termdummies=termindices\[LeftDoubleBracket]i,1\[RightDoubleBracket];
      rule=Thread[termdummies\[Rule]Take[dummies,Length[termdummies]]];
      wsum\[LeftDoubleBracket]i\[RightDoubleBracket]=
        wsum\[LeftDoubleBracket]i\[RightDoubleBracket]/.rule,{i,1,
        Length[wsum]}];
    Plus@@wsum
    ]

SimplifyTensorSum[expr_?(FreeQ[#,Tensor]&)]:=expr



MapLevelParts[func_,
      part:{toppart___Integer?Positive,
          subp:{_Integer?Positive,eprest__Integer?Positive}}][expr_]:=
  Module[{work,subparts,npos,null,i,nnull=Length[{eprest}]},
    work=func@Part[expr,Sequence@@part];
    subparts=Thread[{toppart,subp}];
    newparts={work,Table[null[i],{i,1,nnull}]}//Flatten;
    npos=Partition[Range[nnull+1],1];
    ReplacePart[expr,newparts,subparts,npos]/.null[_]\[Rule]Sequence[]
    ]



SumExpansion[indices:(_Symbol|(f_?IndexFlavorQ)[_Symbol])..][expr_]:=
  SumExpansion[{indices},BaseIndices][expr]

SumExpansion[indices:(_Symbol|(f_?IndexFlavorQ)[_Symbol])..,baseindices_List][
    expr_]:=SumExpansion[{indices},baseindices][expr]

SumExpansion[indices_List,baseindices_:BaseIndices][inexpr_]:=
  Module[{expr=ExpandAll[inexpr],idx,windices,inindex,replace,nrange,nbases},
    
    If[\[Not](Intersection[baseindices,BaseIndices]===Sort[baseindices]),
      Message[SumArrayExpansion::subset,baseindices,BaseIndices];Abort[]];
    nbases=Length[baseindices];
    
    inindex[i_]:=(Count[{expr},
              Tensor[_,up_/;\[Not]FreeQ[up, i|Dif[i]|Cov[i],1],down_]|
                Tensor[_,up_,down_/;\[Not]FreeQ[down,  i|Dif[i]|Cov[i],1]]|
                PartialD[_][_,i]|
                PartialD[_,i],\[Infinity]]>
            0\[And]\[Not]MemberQ[BaseIndices,RawIndex[i]]);
    
    replace[i_,idx_]:=
      i\[RuleDelayed]Switch[Head[i],_?IndexFlavorQ,
          Head[i][baseindices\[LeftDoubleBracket]idx\[RightDoubleBracket]],_,
          baseindices\[LeftDoubleBracket]idx\[RightDoubleBracket]];
    
    Switch[Head[expr],
      List,SumExpansion[indices,baseindices]/@expr,
      Equal,SumExpansion[indices,baseindices]/@expr,
      Power,SumExpansion[indices,baseindices]/@expr,
      Plus,SumExpansion[indices,baseindices]/@expr,
      _,windices=Select[indices,inindex[#]&];
      Fold[Plus@@Table[#1/.replace[#2,idx],{idx,1,nbases}]&,expr,windices]]
    ]



ArrayExpansion[indices:(_Symbol|(f_?IndexFlavorQ)[_Symbol])..][expr_]:=
  ArrayExpansion[{indices},BaseIndices][expr]

ArrayExpansion[indices:(_Symbol|(f_?IndexFlavorQ)[_Symbol])..,
      baseindices_List][expr_]:=ArrayExpansion[{indices},baseindices][expr]

ArrayExpansion[indices_List,baseindices_:BaseIndices][expr_]:=
  Module[{idx,windices,inindex,replace,nrange,nbases},
    
    If[\[Not](Intersection[baseindices,BaseIndices]===Sort[baseindices]),
      Message[SumArrayExpansion::subset,baseindices,BaseIndices];Abort[]];
    nbases=Length[baseindices];
    
    inindex[i_]:=(Count[{expr},
              Tensor[_,up_/;\[Not]FreeQ[up, i|Dif[i]|Cov[i],1],down_]|
                Tensor[_,up_,down_/;\[Not]FreeQ[down,  i|Dif[i]|Cov[i],1]]|
                Tensor[_,up_/;\[Not]FreeQ[up, i|Dif[i]|Cov[i],1],down_][_]|
                
                Tensor[_,up_,
                    down_/;\[Not]FreeQ[down,  i|Dif[i]|Cov[i],1]][_]|
                PartialD[_][_,i]|
                PartialD[_,i],\[Infinity]]>
            0\[And]\[Not]MemberQ[BaseIndices,RawIndex[i]]);
    
    replace[i_,idx_]:=
      i\[RuleDelayed]Switch[Head[i],_?IndexFlavorQ,
          Head[i][baseindices\[LeftDoubleBracket]idx\[RightDoubleBracket]],_,
          baseindices\[LeftDoubleBracket]idx\[RightDoubleBracket]];
    
    windices=Select[indices,inindex[#]&];
    
    Fold[List@@Table[#1/.replace[#2,idx],{idx,1,nbases}]&,expr,
      Reverse[windices]]
    ]



EinsteinSum[][expr_]:=EinsteinSum[BaseIndices][expr]

EinsteinSum[baseindices_List][inexpr_]:=
  Module[{sumindices,expr=ExpandAll[inexpr]},
    Switch[Head[expr],
      List,EinsteinSum[baseindices]/@expr,
      Equal,EinsteinSum[baseindices]/@expr,
      Power,EinsteinSum[baseindices]/@expr,
      Plus,EinsteinSum[baseindices]/@expr,
      _, 
      sumindices=First[ParseTermIndices[expr]];
      If[Length[sumindices]\[Equal]0,Return[expr]];
      SumExpansion[sumindices, baseindices][expr]]
    ]



EinsteinArray[][expr_]:=EinsteinArray[BaseIndices][expr]

EinsteinArray[baseindices_][expr_]:=
  Module[{freeindices},
    freeindices=ExtractFreeIndices[expr];
    If[freeindices===False,Abort[]];
    If[Length[freeindices]==0,Return[expr]];
    freeindices=
      Sort[Flatten[freeindices],OrderedQ[{RawIndex[#1],RawIndex[#2]}]&];
    ArrayExpansion[freeindices, baseindices][expr]
    ]



\!\(\(PartialSum[baseindex_, newindices_List]\)[
      expr_] := \[IndentingNewLine]Module[{baseexpand, freeindices, 
        dummyindices, numdummy, array, 
        newwork}, \[IndentingNewLine]\[IndentingNewLine]baseexpand[
          term_] := \[IndentingNewLine]Module[{iarray = 1, gen, 
            flavors}, \[IndentingNewLine]flavors = \(If[
                  IndexFlavorQ[Head[#]], Head[#], Identity] &\) /@ 
              dummyindices; \[IndentingNewLine]\[IndentingNewLine]gen[
              idepth_, 
              indices_] := \[IndentingNewLine]Module[{}, \
\[IndentingNewLine]If[
                idepth > numdummy, \[IndentingNewLine]array = 
                  ReplacePart[array, 
                    indices, \(iarray++\)], \[IndentingNewLine]gen[
                  idepth + 1, indices]; \[IndentingNewLine]gen[idepth + 1, 
                  ReplacePart[indices, 
                    flavors\_\(\(\[LeftDoubleBracket]\)\(idepth\)\(\
\[RightDoubleBracket]\)\)@baseindex, 
                    idepth]]]\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine]gen[1, 
            dummyindices]; \[IndentingNewLine]Plus @@ \((term /. 
                Thread /@ 
                  MapThread[
                    dummyindices \[Rule] # &, \
{array}])\)\[IndentingNewLine]]; \[IndentingNewLine]\[IndentingNewLine]Switch[
        Head[expr], \[IndentingNewLine]List, 
        PartialSum[baseindex, newindices] /@ expr, \[IndentingNewLine]Equal, 
        PartialSum[baseindex, newindices] /@ expr, \[IndentingNewLine]Plus, 
        PartialSum[baseindex, newindices] /@ 
          expr, \[IndentingNewLine]_, \[IndentingNewLine]If[\[Not] MemberQ[
              BaseIndices, baseindex], 
          Message[PartialSum::baseindex, baseindex, BaseIndices]; 
          Abort[]]; \[IndentingNewLine]{dummyindices, 
            freeindices} = \({Part[#, 1], Flatten[Part[#, 2]]} &\)[
            ParseTermIndices[expr]]; \[IndentingNewLine]newwork = 
          Complement[newindices, freeindices]; \[IndentingNewLine]numdummy = 
          Length[dummyindices]; \[IndentingNewLine]If[
          Length[newwork] < numdummy, 
          Message[PartialSum::newindices, newwork, freeindices, 
            dummyindices]; Abort[]]; \[IndentingNewLine]array = 
          Table[{0, 0}, {2\^numdummy}]; \[IndentingNewLine]baseexpand[expr] /. 
          Thread[dummyindices \[Rule] 
              Take[newwork, Length[dummyindices]]]]\[IndentingNewLine]]\)



\!\(\(PartialArray[baseindex_, newindices_List]\)[
      expr_] := \[IndentingNewLine]Module[{baseexpand, freeindices, 
        dummyindices, numfree, array, 
        newwork}, \[IndentingNewLine]\[IndentingNewLine]baseexpand[
          term_] := \[IndentingNewLine]Module[{iarray = 1, gen, 
            flavors}, \[IndentingNewLine]\[IndentingNewLine]flavors = \(If[
                  IndexFlavorQ[Head[#]], Head[#], Identity] &\) /@ 
              freeindices; \n\[IndentingNewLine]gen[idepth_, 
              indices_] := \[IndentingNewLine]Module[{}, \
\[IndentingNewLine]If[
                idepth > numfree, \[IndentingNewLine]array = 
                  ReplacePart[array, 
                    indices, \(iarray++\)], \[IndentingNewLine]gen[
                  idepth + 1, indices]; \[IndentingNewLine]gen[idepth + 1, 
                  ReplacePart[indices, 
                    flavors\_\(\(\[LeftDoubleBracket]\)\(idepth\)\(\
\[RightDoubleBracket]\)\)@baseindex, 
                    idepth]]]\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine]gen[1, 
            freeindices]; \[IndentingNewLine]\((term /. 
                Thread /@ MapThread[freeindices \[Rule] # &, {array}])\) // 
            Reverse\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine]If[ExtractFreeIndices[expr] === False, 
        Abort[]]; \[IndentingNewLine]\[IndentingNewLine]Switch[
        Head[expr], \[IndentingNewLine]List, 
        PartialArray[baseindex, newindices] /@ 
          expr, \[IndentingNewLine]Equal, 
        PartialArray[baseindex, newindices] /@ expr, \[IndentingNewLine]Plus, 
        PartialArray[baseindex, newindices] /@ 
          expr, \[IndentingNewLine]_, \[IndentingNewLine]If[\[Not] MemberQ[
              BaseIndices, baseindex], 
          Message[PartialArray::baseindex, baseindex, BaseIndices]; 
          Abort[]]; \[IndentingNewLine]{dummyindices, 
            freeindices} = \({Part[#, 1], Flatten[Part[#, 2]]} &\)[
            ParseTermIndices[expr]]; \[IndentingNewLine]newwork = 
          Complement[newindices, dummyindices]; \[IndentingNewLine]numfree = 
          Length[freeindices]; \[IndentingNewLine]If[
          Length[newwork] < numfree, 
          Message[PartialArray::newindices, newwork, dummyindices, 
            freeindices]; Abort[]]; \[IndentingNewLine]array = 
          Table[{0, 0}, {2\^numfree}]; \[IndentingNewLine]baseexpand[expr] /. 
          Thread[
            freeindices \[Rule] Take[newwork, numfree]]]\[IndentingNewLine]]\)



DeclareIndexFlavor[flavor1:{_Symbol,_},
    flavors:{_Symbol,_}..]:=(DeclareIndexFlavor/@{flavor1,flavors};)

DeclareIndexFlavor[{flavorname_Symbol,flavorform_}]:=
  Module[{},
    IndexFlavors=IndexFlavors/.{flavorname,_}\[Rule]Sequence[];
    IndexFlavors=Join[IndexFlavors,{{flavorname,flavorform}}];
    Which[
      Head[flavorform]===RGBColor,
      Format[flavorname[i_]]:=StyleForm[i,FontColor\[Rule]flavorform],
      True,Format[flavorname[i_]]:=flavorform[i]];
    ]

ToFlavor[toflavor_,fromflavor_:Identity][expr_]:=
  Module[{switchQ,replacement,diffcase},
    If[toflavor=!=Identity\[And]Count[IndexFlavors, {toflavor,_}]\[Equal]0,
      Message[Flavor::notflavor,toflavor];Return[expr]];
    
    switchQ[indx_]:=
      Module[{findx},
        findx=
          If[MemberQ[{Dif,Cov},Head[indx]],
            diffcase=True;First[indx],
            diffcase=False;indx];
        Head[findx]===
            fromflavor\[Or](fromflavor===Identity\[And]
              MemberQ[{Symbol,Integer},Head[findx]]\[And]findx=!=Void)
        ];
    
    replacement=
      If[switchQ[#],
          Which[
            fromflavor===Identity\[And]\[Not]diffcase,toflavor@#,
            fromflavor===Identity\[And]diffcase,(toflavor@#&)/@#,
            \[Not]diffcase,toflavor@@#,
            diffcase,(toflavor@@#&)/@#,
            True,Identity@#],
          Identity@#]&;
    
    expr/.Tensor[label_,upindices_,downindices_]\[RuleDelayed]
        Tensor[label,replacement/@upindices,replacement/@downindices]
    ]

ClearIndexFlavor[args:{{_Symbol,_}..}]:=(ClearIndexFlavor/@args;)

ClearIndexFlavor[{flavor_Symbol,_}]:=ClearIndexFlavor[flavor]

ClearIndexFlavor[flavor1_Symbol,
    flavors__Symbol]:=(ClearIndexFlavor/@{flavor1,flavors};)

ClearIndexFlavor[flavor_Symbol]:=
  Module[{},
    If[Count[IndexFlavors, {flavor,_}]\[Equal]0,
      Message[Flavor::notflavor,flavor];Abort[]];
    IndexFlavors=IndexFlavors/.{flavor,_}\[Rule]Sequence[];
    Format[flavor[i_]]=.
    ]

IndexFlavorQ[flavor_]:=MemberQ[IndexFlavors, {flavor,_}]





kSubsets[l_List,0] := { {} }
kSubsets[l_List,1] := Partition[l,1]
kSubsets[l_List,k_Integer?Positive] := {l} /; (k == Length[l])
kSubsets[l_List,k_Integer?Positive] := {}  /; (k > Length[l])
kSubsets[l_List,k_Integer?Positive] :=
	Join[
		Map[(Prepend[#,First[l]])&,kSubsets[Rest[l],k-1]],
		kSubsets[Rest[l],k]
	]

ContractKroneckers[\[Delta]_][expr_]:=
  (expr//KroneckerAbsorb[\[Delta]])/.tensor:
        Tensor[\[Delta],tup_,tdown_]\[RuleDelayed]
      Module[{r,t,n,nup,indices,up,down,sign,voids},
        n=NDim;
        indices=ParseTermIndices[tensor];
        dummies=indices\[LeftDoubleBracket]1\[RightDoubleBracket];
        t=Length[dummies];
        {up,down}=indices\[LeftDoubleBracket]2\[RightDoubleBracket];
        nup=Length[up];
        If[nup\[NotEqual]Length[down],
          Message[ContractKroneckers::indices,tensor];Abort[]];
        r=t+nup;
        voids=Array[Void&,nup];
        sign=
          Signature[If[MemberQ[dummies, #],#,Unevaluated[Sequence[]]]&/@tup]/
            Signature[
              If[MemberQ[dummies, #],#,Unevaluated[Sequence[]]]&/@tdown];
        sign *
          Which[
            t==0,tensor,
            
            nup>0,(n-r+t)!/(n-r)!  Tensor[\[Delta],{Sequence@@up,
                  Sequence@@voids},{Sequence@@voids,Sequence@@down}],
            True,(n-r+t)!/(n-r)! ]
        ]

FullKroneckerExpand[\[Delta]_][expr_]:=
  (expr//ContractKroneckers[\[Delta]])/.tensor:
        Tensor[\[Delta],_,_]\[RuleDelayed]
      Module[{up,down},
        {up,down}=
          ParseTermIndices[tensor]\[LeftDoubleBracket]2\[RightDoubleBracket];
        If[Length[up]\[NotEqual]Length[down],
          Message[FullKroneckerExpand::indices,tensor];Abort[]];
        Det[Outer[Tensor[\[Delta],{#1,Void},{Void,#2}]&,up,down]]
        ]

PartialKroneckerExpand[\[Delta]_Symbol,order_Integer?Positive,
      suborder_Integer?Positive,expandup_:True][expr_]:=
  expr/.tensor:Tensor[\[Delta],u_,_]/;
        Length[u]==2 order\[And]Length[u]>2suborder\[RuleDelayed]
      Module[{up,down,up1,up2,down1,down2,signs,voids1,voids2},
        {up,down}=
          ParseTermIndices[tensor]\[LeftDoubleBracket]2\[RightDoubleBracket];
        If[Length[up]\[NotEqual]Length[down],
          Message[PartialKroneckerExpand::indices,tensor];Abort[]];
        
        If[expandup=!=False,
          up1=Take[up,suborder];
          up2=Drop[up,suborder];
          down1=kSubsets[down,suborder];
          down2=Complement[down,#]&/@down1;
          
          signs=Signature[#]/Signature[down]&/@
              MapThread[Join[#1,#2]&,{down1,down2}],
          
          down1=Take[down,suborder];
          down2=Drop[down,suborder];
          up1=kSubsets[up,suborder];
          up2=Complement[up,#]&/@up1;
          
          signs=Signature[#]/Signature[up]&/@
              MapThread[Join[#1,#2]&,{up1,up2}]
          ];
        voids1=Array[Void&,suborder];
        voids2=Array[Void&,order-suborder];
        If[expandup,
          
          Plus@@MapThread[#1Tensor[\[Delta],Join[up1,voids1],
                    Join[voids1,#2]]Tensor[\[Delta],Join[up2,voids2],
                    Join[voids2,#3]]&,{signs,down1,down2}],
          
          Plus@@MapThread[#1Tensor[\[Delta],Join[#2,voids1],
                    Join[voids1,down1]]Tensor[\[Delta],Join[#3,voids2],
                    Join[voids2,down2]]&,{signs,up1,up2}]]
        ]



ClearAll[KmatchQ];
Attributes[KmatchQ]={HoldAll};
KmatchQ[dummyindx_,newindex_,\[Delta]t_,subexpr_]:=
  Module[{dum,dummies,i,up\[Delta],upsub,down\[Delta],downsub,returnval},
    dummies=First[ParseTermIndices[\[Delta]t subexpr]];
    If[Length[dummies]==0,Return[False]];
    dummies=Sort[dummies,RawIndex[#1]<RawIndex[#2]&];
    up\[Delta]=Part[\[Delta]t,2]/.Void\[Rule]Sequence[];
    down\[Delta]=Part[\[Delta]t,3]/.Void\[Rule]Sequence[];
    upsub=Part[ParseTermIndices[subexpr],2,1];
    downsub=Part[ParseTermIndices[subexpr],2,2];
    returnval=False;
    Do[
      dum=Part[dummies,i];
      Which[
        MemberQ[up\[Delta],dum]\[And]MemberQ[downsub,dum],
        dummyindx=dum;newindex=First[down\[Delta]];returnval=True;Return[],
        MemberQ[down\[Delta],dum]\[And]MemberQ[upsub,dum],
        dummyindx=dum;newindex=First[up\[Delta]];returnval=True;Return[]],
      {i,1,Length[dummies]}];
    returnval
    ]

KroneckerAbsorb[\[Delta]_][expr_]:= 
  Module[{\[Delta]ten,tpatt,dummy,newindex},
    \[Delta]ten=
      Tensor[\[Delta],{_,Void},{Void,_}]|Tensor[\[Delta],{Void,_},{_,Void}];
    expr//.(\[Delta]t:\[Delta]ten) subexpr_+a_./;
          KmatchQ[dummy,newindex,\[Delta]t,subexpr]\[RuleDelayed]
        Module[{b,postensor},
          postensor=Position[subexpr,Tensor[_,b__]/;\[Not]FreeQ[{b},dummy]];
          
          ReplacePart[subexpr, 
              ReplaceIndex[dummy,newindex][
                First[Extract[subexpr,postensor]]], postensor]+a
          ]
        ]

PermutationPseudotensor[n_]:=
  Module[
    {indxs=Table[Unique[q],{n}],iters},
    iters=MapThread[{#1,1,n}&,{indxs}];
    Table[Signature[indxs],Evaluate[Sequence@@iters]]
    ]

PermutationSymbolRule[e_]:=
  Tensor[e,ups_List,downs_List]/;
      Module[{},
        Which[
          Length[ups]\[NotEqual]NDim,False,
          Length[downs]\[NotEqual]NDim,False,
          \[Not]SameQ@@(Head/@ups),False,
          \[Not]SameQ@@(Head/@downs),False,
          \[Not](And@@(#===Void&/@ups))\[And](And@@(#=!=Void&/@downs)),False,
          \[Not](And@@(#===Void&/@downs))\[And](And@@(#=!=Void&/@ups)),False,
          First[ups]===Void\[And]\[Not](And@@(BaseIndexQ/@downs)),False,
          First[downs]===Void\[And]\[Not](And@@(BaseIndexQ/@ups)),False,
          True,True]
        ]\[RuleDelayed]
    Signature[BaseIndices]If[
        First[ups]===Void,Signature[downs],Signature[ups]]





Attributes[MmatchQ]={HoldAll};
MmatchQ[dummyindx_,newindex_,routine_,mt_,subexpr_]:=
  Module[{dum,dummies,i,upm,upsub,downm,downsub,returnval},
    dummies=First[ParseTermIndices[mt subexpr]];
    If[Length[dummies]==0,Return[False]];
    dummies=Sort[dummies,OrderedQ[{RawIndex[#1],RawIndex[#2]}]&];
    
    upm=Part[ParseTermIndices[mt],2,1];
    downm=Part[ParseTermIndices[mt],2,2];
    If[Head[#1]=!=Head[#2]&@@Join[upm,downm],Return[False]];
    upsub=Part[ParseTermIndices[subexpr],2,1];
    downsub=Part[ParseTermIndices[subexpr],2,2];
    
    returnval=False;
    Do[
      dum=Part[dummies,i];
      Which[
        
        Length[upm]==2\[And]MemberQ[upm,dum]\[And]MemberQ[downsub,dum],
        dummyindx=dum;
        newindex=First[Complement[upm,{dum}]];
        routine=RaiseIndex;
        returnval=True;
        Return[],
        
        Length[downm]==2\[And]MemberQ[downm,dum]\[And]MemberQ[upsub,dum],
        dummyindx=dum;
        newindex=First[Complement[downm,{dum}]];
        routine=LowerIndex;
        returnval=True;
        Return[],
        
        Length[upm]==1\[And]MemberQ[upm,dum]\[And]MemberQ[downsub,dum],
        dummyindx=dum;
        newindex=First[downm];
        routine=ReplaceIndex;
        returnval=True;
        Return[],
        
        Length[downm]==1\[And]MemberQ[downm,dum]\[And]MemberQ[upsub,dum],
        dummyindx=dum;
        newindex=First[upm];
        routine=ReplaceIndex;
        returnval=True;
        Return[]
        ],
      {i,1,Length[dummies]}];
    
    returnval
    ]

MetricSimplify[g_][expr_]:= 
  Module[{gten,tpatt,dummy,newindex,routine,reverse,wexpr},
    gten=Tensor[g,{_,_},{_,_}];
    wexpr=
      expr//.(gt:gten) subexpr_+a_./;
            MmatchQ[dummy,newindex,routine,gt,subexpr]\[RuleDelayed]
           Module[{b,postensor},
            
            reverse=False;
            Which[
              (postensor=
                    Position[subexpr,
                      PartialD[_][_,
                        Tensor[_,b__]/;\[Not]FreeQ[{b},dummy]]])=!={},
              reverse=True,
              (postensor=
                    Position[subexpr,
                      PartialD[_][_,{___,
                            Tensor[_,b__],___}/;\[Not]FreeQ[{b},
                              dummy]]])=!={},reverse=True];
            
            
            postensor=
              Position[subexpr,Tensor[_,b__]/;\[Not]FreeQ[{b},dummy]];
            If[reverse,
              
              Switch[routine,LowerIndex,routine=RaiseIndex,RaiseIndex,
                routine=LowerIndex]];
            
            
            ReplacePart[subexpr, 
                routine[dummy,newindex][First[Extract[subexpr,postensor]]], 
                postensor]+a
            ];
    wexpr/.a:(Tensor[g,{i_?BaseIndexQ,Void},{Void,j_?BaseIndexQ}]|
              Tensor[g,{Void,j_?BaseIndexQ},{i_?BaseIndexQ,
                  Void}])\[RuleDelayed]
         Which[Head[i]=!=Head[j],a,
          i===j,1,
          True,0]
        ]





UseCoordinates[namelist_List/;Length[namelist]\[Equal]NDim,x_:Global`x,
      flavor_:Identity][expr_]:=
  Module[{symlist,expr2=expr},
    symlist=If[Head[#]===Tensor,First[#],#]&/@namelist;
    
    expr2=
      expr2/.HoldPattern[
            PartialD[_][T_,Tensor[_,{i_?BaseIndexQ},{Void}]]]\[RuleDelayed]
          With[{var=Part[namelist,First@First@Position[BaseIndices,i]]},
            HoldForm[D[T,var]]];
    
    expr2=
      expr2/.Thread[
          Table[Tensor[
                  x,{BaseIndices\[LeftDoubleBracket]
                      i\[RightDoubleBracket]},{Void}]//ToFlavor[flavor],{i,1,
                NDim}]\[Rule]namelist]
    ]

UseCoordinates[x_:Global`x,flavor_:Identity][expr_]:=
  If[Length[BaseIndices]>0\[And]And@@(Head[#]===Symbol&/@BaseIndices),
    UseCoordinates[BaseIndices,x,flavor][expr],expr]

CoordinatesToTensors[coordinates_List,xlab_:Global`x,flavor_:Identity][expr_]:=
  
  expr/.Thread[
      coordinates\[Rule]
        Table[Tensor[xlab,{flavor@Part[BaseIndices,i]},{Void}],{i,1,NDim}]]



SymmetrizeSlots[label_,order_,symmetry:{-1|1,{_,__}}][expr_]:=
  SymmetrizeSlots[label,order,{symmetry}][expr]

SymmetrizeSlots[label_,order_,symmetries:{{-1|1,{_,__}}..}][expr_]:=
  expr/.Tensor[label,up_List,down_List]/;
        Length[up]==Length[down]==order\[RuleDelayed]
      
      Module[{slots,slotindices,sign=1,symsign,symslots,symindices,
          symordering,n=Length[symmetries],i,temp},
        slots=Transpose[{up,down}];
        slotindices = Flatten[slots]/.Void\[Rule]Sequence[];
        Do[
          {symsign,symslots}=
            symmetries\[LeftDoubleBracket]i\[RightDoubleBracket];
          
          symindices=
            slotindices\[LeftDoubleBracket]symslots\[RightDoubleBracket];
          symordering=Ordering[symindices];
          sign*=If[symsign==1,1,Signature[symordering]];
          
          slots\[LeftDoubleBracket]symslots\[RightDoubleBracket]=
            slots\[LeftDoubleBracket]
                symslots\[RightDoubleBracket]\[LeftDoubleBracket]
              symordering\[RightDoubleBracket];
          
          slotindices \[LeftDoubleBracket]symslots\[RightDoubleBracket]=
            slotindices \[LeftDoubleBracket]
                symslots\[RightDoubleBracket]\[LeftDoubleBracket]
              symordering\[RightDoubleBracket],
          {i,1,n}];
        sign Tensor[label,Sequence@@Transpose[slots]]
        ]

\!\(\(Symmetric[ind_]\)[
      term_] := \[IndentingNewLine]Module[{indperm, tens, upindices, 
        downindices, 
        numindices = Length[ind]}, \[IndentingNewLine]{upindices, 
          downindices} = 
        Part[ParseTermIndices[term], 
          2]; \[IndentingNewLine]If[\[Not] \((Count[ind, 
                  Alternatives @@ upindices] \[Equal] numindices \[Or] 
              Count[ind, Alternatives @@ downindices] \[Equal] 
                numindices)\), \[IndentingNewLine]Message[Symmetric::indices, 
          ind, upindices, downindices]; 
        Abort[]]; \[IndentingNewLine]indperm = Permutations[ind]; 
      tens = term /. \[InvisibleSpace]\((MapThread[Rule, {ind, #1}] &)\) /@ 
            indperm; \[IndentingNewLine]Plus @@ tens\/Length[indperm]]\)

\!\(\(AntiSymmetric[ind_]\)[
      term_] := \[IndentingNewLine]Module[{indperm, signs, tens, upindices, 
        downindices, 
        numindices = Length[ind]}, \[IndentingNewLine]{upindices, 
          downindices} = 
        Part[ParseTermIndices[term], 
          2]; \[IndentingNewLine]If[\[Not] \((Count[ind, 
                  Alternatives @@ upindices] \[Equal] numindices \[Or] 
              Count[ind, Alternatives @@ downindices] \[Equal] 
                numindices)\), \[IndentingNewLine]Message[
          AntiSymmetric::indices, ind, upindices, downindices]; 
        Abort[]]; \[IndentingNewLine]indperm = 
        Permutations[ind]; \[IndentingNewLine]signs = \((Signature[##1] &)\) /@ 
          indperm; 
      tens = term /. \[InvisibleSpace]\((MapThread[Rule, {ind, #1}] &)\) /@ 
            indperm; \[IndentingNewLine]\(Signature[ind]\ signs . \
tens\)\/Length[indperm]]\)



DefineTensorShortcuts[args:{_,_}..]:=(DefineTensorShortcuts@@#&/@{args};)

DefineTensorShortcuts[labels_List,
    order_Integer?Positive]:=(DefineTensorShortcuts[#,order]&/@labels;)

DefineTensorShortcuts[lab_,order_Integer?Positive]:=
  Module [{suffixes={"u","d"},names,udpattern,upindices,downindices,indices},
    names=
      Flatten[Outer[Symbol[SymbolName[lab]<>##]&,
          Sequence@@Table[suffixes,{order}]]];
    udpattern=Outer[{##}&,Sequence@@Table[suffixes,{order}]];
    upindices=
      Flatten[Map[If[#==="u",Unique["u"],Void]&,udpattern,{order+1}],
        order-1];
    downindices=
      Flatten[Map[If[#==="d",Unique["d"],Void]&,udpattern,{order+1}],
        order-1];
    udpattern=Join[{names},{upindices},{downindices}]//Transpose;
    Clear@@names;
    Module[{indices},
              indices=Flatten[Transpose[{#2,#3}]]/.Void\[Rule]Sequence[];
              indices=Pattern[#,Blank[]]&/@indices;
              Evaluate[#1@@indices]:=Tensor[lab,#2,#3]]&@@#&/@udpattern;
    ]

ClearTensorShortcuts[args:{_,_}..]:=(ClearTensorShortcuts@@#&/@{args};)

ClearTensorShortcuts[labels_List,
    order_Integer?Positive]:=(ClearTensorShortcuts[#,order]&/@labels;)

ClearTensorShortcuts[lab_,order_Integer?Positive]:=
  Module [{suffixes={"u","d"},names},
    names=
      Flatten[Outer[Symbol[SymbolName[lab]<>##]&,
          Sequence@@Table[suffixes,{order}]]];
    Clear@@names;
    ]



TensorValueRules[labels__]/;Length[{labels}]>1:=
  Fold[Join,{},
    If[Head[TensorValueRules[#]]===TensorValueRules,{},
          TensorValueRules[#]]&/@{labels}]



Attributes[SetTensorValues]={HoldFirst};
SetTensorValues[tensor_,values_,permissive_:False]:=
  Module[{test=Hold[tensor]},
    Switch[test,
      HoldPattern[Hold[Tensor[_]]],SetTensorValues1[tensor,values],
      _,SetTensorValues2[tensor,values,permissive]]]

Attributes[SetTensorValues1]={HoldFirst};
SetTensorValues1[Tensor[label_],value_]:=
  Module[{oldupvalues},
    ClearTensorValues[Tensor[label]];
    oldupvalues=UpValues[label];
    UpValues[label]={};
    label/:Tensor[label]=value;
    oldupvalues=
      Complement[oldupvalues,UpValues[label],
        SameTest\[Rule](First[#1]===First[#2]&)];
    UpValues[label]=Union[UpValues[label],oldupvalues];
    ]

SetTensorValues2[tensorin:Tensor[label_,upindices_,downindices_],values_List,
    permissive_]:=
  Module[
    {tensor=tensorin,
      indices,iterators,iter,temptensor1,temptensor2,oldupvalues,i,
      uniqueindexrules,work},
    
    If[\[Not](permissive\[Or]SameQ@@Join[Dimensions[values],{NDim}]),
      Message[SetTensorValues::size];Return[$Failed]];
    ClearTensorValues[tensor];
    indices=
      Join[upindices,downindices]/.{Void\[RuleDelayed]Sequence[],
          x_?(MemberQ[BaseIndices, #]&)\[RuleDelayed]Sequence[]};
    indices =RawIndex/@indices;
    indices=Sort[indices];
    work=Unique/@indices;
    uniqueindexrules= Thread[indices\[Rule]work];
    indices=work;
    tensor=MapAt[#/.uniqueindexrules&,tensor,{{2},{3}}];
    
    If[Length[indices]>Length[Dimensions[values]],
      Message[SetTensorValues::dim];Return[$Failed]];
    iterators=
      Table[{indices\[LeftDoubleBracket]iter\[RightDoubleBracket],1,
          NDim},{iter,1,Length[indices]}];
    oldupvalues=UpValues[label];
    UpValues[label]={};
    temptensor1=
      tensor/.i_Integer\[RuleDelayed]
          Position[BaseIndices,i]\[LeftDoubleBracket]1,
            1\[RightDoubleBracket];
    
    Do[temptensor2=
        temptensor1/.(i_Integer/;1\[LessEqual]i\[LessEqual]NDim)\[RuleDelayed]
            BaseIndices\[LeftDoubleBracket]i\[RightDoubleBracket];
      label/:Evaluate[temptensor2]=Part[values,Sequence@@indices],
      Evaluate[Sequence@@iterators]];
    
    oldupvalues=
      Complement[oldupvalues,UpValues[label],
        SameTest\[Rule](First[#1]===First[#2]&)];
    UpValues[label]=Union[UpValues[label],oldupvalues];
    ]



SetTensorValueRules[intensor:Tensor[label_,upindices_,downindices_],
    values_List,permissive_:False]:=
  Module[
    {tensor=intensor,indices,iterators,iter,temptensor1,temptensor2,oldrules,
      i,uniqueindexrules,work},
    
    If[\[Not](permissive\[Or]SameQ@@Join[Dimensions[values],{NDim}]),
      Message[SetTensorValueRules::size];Return[$Failed]];
    ClearTensorValues[tensor];
    indices=
      Join[upindices,downindices]/.{Void\[RuleDelayed]Sequence[],
          x_?(MemberQ[BaseIndices, #]&)\[RuleDelayed]Sequence[]};
    indices = RawIndex/@indices;
    indices=Sort[indices];
    work=Unique/@indices;
    uniqueindexrules= Thread[indices\[Rule]work];
    indices=work;
    tensor=MapAt[#/.uniqueindexrules&,tensor,{{2},{3}}];
    
    If[Length[indices]>Length[Dimensions[values]],
      Message[SetTensorValueRules::dim];Return[$Failed]];
    iterators=
      Table[{indices\[LeftDoubleBracket]iter\[RightDoubleBracket],1,
          NDim},{iter,1,Length[indices]}];
    oldrules=
      If[Head[TensorValueRules[label]]===TensorValueRules,{},
        TensorValueRules[label]];
    TensorValueRules[label]={};
    temptensor1=
      tensor/.i_Integer\[RuleDelayed]
          Position[BaseIndices,i]\[LeftDoubleBracket]1,
            1\[RightDoubleBracket];
    
    Do[temptensor2=
        temptensor1/.(i_Integer/;1\[LessEqual]i\[LessEqual]NDim)\[RuleDelayed]
            BaseIndices\[LeftDoubleBracket]i\[RightDoubleBracket];
      TensorValueRules[label]={TensorValueRules[label],
          Evaluate[temptensor2]\[Rule]Part[values,Sequence@@indices]},
      Evaluate[Sequence@@iterators]];
    TensorValueRules[label]=Flatten[TensorValueRules[label]];
    
    oldrules=
      Complement[oldrules,TensorValueRules[label],
        SameTest\[Rule](First[#1]===First[#2]&)];
    TensorValueRules[label]=Union[TensorValueRules[label],oldrules];
    ]

SetTensorValueRules[Tensor[label_],value_]:=
  Module[{oldrules},
    ClearTensorValues[Tensor[label]];
    oldrules=
      If[Head[TensorValueRules[label]]===TensorValueRules,{},
        TensorValueRules[label]];
    TensorValueRules[label]={};
    TensorValueRules[label]= {Tensor[label]\[Rule]value};
    oldrules=
      Complement[oldrules,TensorValueRules[label],
        SameTest\[Rule](First[#1]===First[#2]&)];
    TensorValueRules[label]=Union[TensorValueRules[label],oldrules];
    ]



Attributes[ClearTensorValues]={HoldFirst};
ClearTensorValues[tensors_?VectorQ]:=(ClearTensorValues/@tensors;)

ClearTensorValues[tensor_]:=
  Module[{test=Hold[tensor]},
    Switch[test,
      Hold[Tensor[_]],ClearTensorValues1[tensor],
      _,ClearTensorValues2[tensor]]]



Attributes[ClearTensorValueRules]={HoldFirst};
ClearTensorValueRules[tensor_]:=
  Module[{test=Hold[tensor]},
    Switch[test,
      Hold[Tensor[_]],ClearTensorValueRules1[tensor],
      _,ClearTensorValueRules2[tensor]]]

Attributes[ClearTensorValueRules1]={HoldFirst};
ClearTensorValueRules1[tensor:Tensor[label_]]:=
  Module[{},
    If[Head[TensorValueRules[label]]===TensorValueRules, Return[]];
    TensorValueRules[label]=
      Select[TensorValueRules[label],
        FreeQ[{First[#]},HoldPattern[Tensor[label]]]&]
    ]

ClearTensorValueRules2[tensorin:Tensor[label_,upindices_,downindices_]]:=
  Module[
    {tensor=tensorin,
      indices,iterators,iter,temptensor1,temptensor2,oldrules,i,
      uniqueindexrules,work},
    indices=
      Join[upindices,downindices]/.{Void\[RuleDelayed]Sequence[],
          x_?(MemberQ[BaseIndices, #]&)\[RuleDelayed]Sequence[]};
    indices = RawIndex/@indices;
    indices=Sort[indices];
    work=Unique/@indices;
    uniqueindexrules= Thread[indices\[Rule]work];
    indices=work;
    tensor=MapAt[#/.uniqueindexrules&,tensor,{{2},{3}}];
    
    iterators=
      Table[{indices\[LeftDoubleBracket]iter\[RightDoubleBracket],1,
          NDim},{iter,1,Length[indices]}];
    oldrules=
      If[Head[TensorValueRules[label]]===TensorValueRules,{},
        TensorValueRules[label]];
    TensorValueRules[label]={};
    temptensor1=
      tensor/.i_Integer\[RuleDelayed]
          Position[BaseIndices,i]\[LeftDoubleBracket]1,
            1\[RightDoubleBracket];
    
    Do[temptensor2=
        temptensor1/.(i_Integer/;1\[LessEqual]i\[LessEqual]NDim)\[RuleDelayed]
            BaseIndices\[LeftDoubleBracket]i\[RightDoubleBracket];
      TensorValueRules[label]={TensorValueRules[label],
          Evaluate[temptensor2]\[Rule]Null},
      Evaluate[Sequence@@iterators]];
    TensorValueRules[label]=Flatten[TensorValueRules[label]];
    
    TensorValueRules[label]=
      Complement[oldrules,TensorValueRules[label],
        SameTest\[Rule](First[#1]===First[#2]&)];
    ]



Attributes[ClearTensorValues1]:={HoldFirst};
ClearTensorValues1[Tensor[label_]]:=
  Module[{},
    UpValues[label]=
      Select[UpValues[label],FreeQ[First[#],HoldPattern[Tensor[label]]]&];
    ClearTensorValueRules[Tensor[label]];
    ]

ClearTensorValues2[tensorin:Tensor[label_,upindices_,downindices_]]:=
  Module[
    {tensor=Evaluate[tensorin],indices,iterators,iter,temptensor1,temptensor2,
      oldupvalues,i,uniqueindexrules,work},
    indices=
      Join[upindices,downindices]/.{Void\[RuleDelayed]Sequence[],
          x_?(MemberQ[BaseIndices, #]&)\[RuleDelayed]Sequence[]};
    indices =RawIndex/@indices;
    indices=Sort[indices];
    work=Unique/@indices;
    uniqueindexrules= Thread[indices\[Rule]work];
    indices=work;
    tensor=MapAt[#/.uniqueindexrules&,tensor,{{2},{3}}];
    
    iterators=
      Table[{indices\[LeftDoubleBracket]iter\[RightDoubleBracket],1,
          NDim},{iter,1,Length[indices]}];
    oldupvalues=UpValues[label];
    UpValues[label]={};
    temptensor1=
      tensor/.i_Integer\[RuleDelayed]
          Position[BaseIndices,i]\[LeftDoubleBracket]1,
            1\[RightDoubleBracket];
    
    Do[temptensor2=
        temptensor1/.(i_Integer/;1\[LessEqual]i\[LessEqual]NDim)\[RuleDelayed]
            BaseIndices\[LeftDoubleBracket]i\[RightDoubleBracket];
      label/:Evaluate[temptensor2]=Null,Evaluate[Sequence@@iterators]];
    
    UpValues[label]=
      Complement[oldupvalues,UpValues[label],
        SameTest\[Rule](First[#1]===First[#2]&)];
    ClearTensorValueRules[Tensor[label,upindices,downindices]];
    ]

NonzeroValueRules[labels__]:=
  Cases[TensorValueRules[labels],HoldPattern[Rule[_,rhs_/;rhs=!=0]]]



DeclareZeroTensor[lab_]:=
  lab/:Tensor[
      lab,{_?(FreeQ[#,
                    Pattern]\[And](#===Void\[Or]
                      BaseIndexQ[#])&)..},{_?(FreeQ[#,
                    Pattern]\[And](#===Void\[Or]BaseIndexQ[#])&)..}]:=0



SetMetricValueRules[g_,MT_,flavor_:Identity]:=
  Module[{i,j},
    SetTensorValueRules[Tensor[g,{Void,Void},{i,j}]//ToFlavor[flavor],MT];
    SetTensorValueRules[Tensor[g,{i,j},{Void,Void}]//ToFlavor[flavor],
      Simplify[Inverse[MT]]]
    ]

SetMetricValues[g_,MT_,flavor_:Identity]:=
  Module[{i,j},
    SetTensorValues[Tensor[g,{Void,Void},{i,j}]//ToFlavor[flavor],MT];
    SetTensorValues[Tensor[g,{i,j},{Void,Void}]//ToFlavor[flavor],
      Simplify[Inverse[MT]]]
    ]

\!\(\(\[CapitalGamma]\^\[Lambda]\)\_\[Mu]\[Nu] = \(1\/2\) \(g\^\[Lambda]\
\[Sigma]\) \((\[PartialD]\_\[Mu]\ g\_\[Sigma]\[Nu] + \[PartialD]\_\[Nu]\ 
            g\_\[Sigma]\[Mu] - \[PartialD]\_\[Sigma]\ g\_\[Mu]\[Nu])\)\)



extractFlavor[x_Tensor]:=
  Module[{flavor},
    flavor=Head[Part[x,2,1]];
    Which[
      IndexFlavorQ[flavor],flavor,
      flavor===Symbol,Identity,
      True,Message[Flavor::notflavor,flavor];Abort[]]]



CalculateChristoffelu[x_Tensor,MT_,simplifyfunc_:Identity]:=
  Module[
    {G,DD,d,l,m,n,s,ll,mm,nn,ss,Chr,flavor},
    d = Length[MT];
    flavor=extractFlavor[x];
    SetMetricValueRules[G,  MT,flavor];
    
    Gdd[s_,n_]=Tensor[G,{Void,Void},{s,n}]//ToFlavor[flavor];
    Guu[s_,n_]=Tensor[G,{s,n},{Void,Void}]//ToFlavor[flavor];
    xu[n_]=Tensor[First[x],{n},{Void}]//ToFlavor[flavor];
    
    Chr=Table[
          l=Part[BaseIndices,ll];
          m=Part[BaseIndices,mm];
          n=Part[BaseIndices,nn];
          Sum[
            s=Part[BaseIndices,ss];
            
            Guu[l,s](DD[Gdd[s,n],xu[m]]+DD[Gdd[s,m],xu[n]]-
                  DD[Gdd[m,n],xu[s]])
            ,{ss,1,d}]
          
          ,{ll,1,d},{mm,1,d},{nn,1,d}]/2;
    Chr=(Chr/.TensorValueRules[G])/.DD\[RuleDelayed]D;
    ClearTensorValues/@{Gdd[mm,nn],Guu[mm,nn]};
    Map[simplifyfunc,Chr,{3}]
    ]

CalculateChristoffeld[x_Tensor,MT_,simplifyfunc_:Identity]:=
    Module[{G,DD,d,m,n,s,mm,nn,ss,Chr,flavor},
      d = Length[MT];
      flavor=extractFlavor[x];
      SetMetricValueRules[G,  MT,flavor];
      
      Gdd[s_,n_]=Tensor[G,{Void,Void},{s,n}]//ToFlavor[flavor];
      Guu[s_,n_]=Tensor[G,{s,n},{Void,Void}]//ToFlavor[flavor];
      xu[n_]=Tensor[First[x],{n},{Void}]//ToFlavor[flavor];
      
      Chr=Table[
            m=Part[BaseIndices,mm];
            n=Part[BaseIndices,nn];
            s=Part[BaseIndices,ss];
            
            DD[Gdd[s,n],xu[m]]+DD[Gdd[s,m],xu[n]]-DD[Gdd[m,n],xu[s]]
            
            ,{ss,1,d},{mm,1,d},{nn,1,d}]/2;
      
      Chr=(Chr/.TensorValueRules[G])/.DD\[RuleDelayed]D;
      ClearTensorValues/@{Gdd[mm,nn],Guu[mm,nn]};
      Map[simplifyfunc,Chr,{3}]
      ];

SetChristoffelValueRules[x_Tensor,MT_,\[CapitalGamma]_,
    simplifyfunc_:Identity]:=
  Module[{l,m,n,flavor},
    flavor=extractFlavor[x];
    SetTensorValueRules[
       Tensor[\[CapitalGamma],{l,Void,Void},{Void,m,n}] //ToFlavor[flavor],
      CalculateChristoffelu[x,MT,simplifyfunc]
      ];
    SetTensorValueRules[
       Tensor[\[CapitalGamma],{Void,Void,Void},{l,m,n}] //ToFlavor[flavor],
      CalculateChristoffeld[x,MT,simplifyfunc]
      ];
    ]

SetChristoffelValues[x_Tensor,MT_,\[CapitalGamma]_,simplifyfunc_:Identity]:=
  Module[{l,m,n,flavor},
    flavor=extractFlavor[x];
    SetTensorValues[
       Tensor[\[CapitalGamma],{l,Void,Void},{Void,m,n}] //ToFlavor[flavor],
      CalculateChristoffelu[x,MT,simplifyfunc]
      ];
    SetTensorValues[
       Tensor[\[CapitalGamma],{Void,Void,Void},{l,m,n}] //ToFlavor[flavor],
      CalculateChristoffeld[x,MT,simplifyfunc]
      ];
    ]





PartialD[u_?NumericQ,__]:=0;

PartialD[u_Symbol,__]:=0;

PartialD[Tensor[T_,sup_,sub_],j_]:=Module[{},
        newup = Map[Void&,j];
        newsub=Map[Dif,j];
        Tensor[T,Join[sup,newup],Join [sub,newsub]]
         ]/;VectorQ[j];

PartialD[Tensor[T_,sup_,sub_],j_]:=Module[{},
        Tensor[T,Join[sup,{Void}],Join [sub,{Dif[j]}]]
         ]/;Not[VectorQ[j]];

PartialD[w_Plus,j_]:=(PartialD[#1,j]&)/@w;

PartialD[w_ u_,j_]:=PartialD[w,j] u+PartialD[u,j] w/;VectorQ[j]===False;

PartialD[Dot[w_ ,u_],j_]:=
    Dot[PartialD[w,j], u]+Dot[PartialD[u,j] ,w]/;VectorQ[j]===False;

PartialD[w_ u_,j_List]:=Fold[PartialD[#1,#2]&,w u,j];



PartialD[Tensor[T_],j_]:=Module[{},
    Tensor[T,{Void},{Dif[j]}]
     ]

PartialD[Tensor[T_],j_List]:=Module[{},
    up = Map[Void&,j];
    sub=Map[Dif,j];
    Tensor[T,up,sub]
     ]



GetDif[Tensor[T_,sup_,sub_]]:=
    Module[{x,sub2,sub3},
      sub2=Cases[sub,Dif[_]] ;  
      sub3=sub2/.Dif[x_]\[Rule]x
      ];

DropDif[Tensor[T_,sup_,sub_]]:=Module[{indT},
      indT=Transpose[{sup,sub}]/.{Void,Dif[_]}\[Rule]Sequence[];
      If[indT\[Equal]{},Tensor[T],Tensor[T,Sequence@@Transpose[indT]   ]]
      ];

ExpandPartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][w_]:=
    Module[{ind},
      w/.Tensor[T_,ind__]\[RuleDelayed] 
          PartialD[{x,\[Delta],g,\[CapitalGamma]}][   
            DropDif[Tensor[T,ind ]]    , 
            Map[Tensor[x,{#} ,{Void}]&,GetDif[Tensor[T,ind  ]]  ] ]
      ];



PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][w_,v_List]:=
    D[w,Sequence@@v]/;FreeTensorQ[w]&&(And@@Map[FreeTensorQ[#]&,v]);

PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][w_,v_]:=
  D[w,v]/;FreeTensorQ[w]&&FreeTensorQ[v]



PartialD[_][ a_?NumericQ  , _ ] := 0;

PartialD[_][ a_  , a_ ]:=1;

PartialD[_][u_Symbol,v__ ]:=0/;MemberQ[Attributes[u],Constant]

PartialD[labels_][ T_Plus , v_ ]:= PartialD[labels][#,v]& /@ T;

HoldPattern[PartialD[labels_][Dot[w_ ,u_],j_]]:=
    Dot[PartialD[labels][w,j], u]+Dot[PartialD[labels][u,j] ,w]/;
      VectorQ[j]===False;

PartialD[labels_][ T_*U_ , v_ ]:= 
    PartialD[labels][T,v]*U + T*PartialD[labels][U,v]/;
      VectorQ[v]\[Equal]False;

PartialD[w_ ,{}]:=w;

PartialD[labs_][w_ ,{}]:=w;

PartialD[w_ ,{i_}]:=PartialD[w ,i];

PartialD[labs_][w_ ,{i_}]:=PartialD[labs][w,i];



PartialD[labs_][T_,u_List]/;\[Not]OrderedQ[u]:=PartialD[labs][T,Sort[u]]



PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][ Tensor[x_,{i_},{Void}] ,
        Tensor[x_,{j_},{Void}] ]/;(Head[i]===Head[j]&&Not[VectorQ[j]])=
    Tensor[\[Delta],{i,Void},{Void,j}];

PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][ Tensor[x_,{Void},{i_}] ,
        Tensor[x_,{Void},{j_}] ]/;(Head[i]===Head[j]&&Not[VectorQ[j]])=
    Tensor[\[Delta],{j,Void},{Void,i}];

FilterPD[Void,Void]:=Sequence[];
FilterPD[i_,Void]:=i;
FilterPD[Void,i_]:=i;
HoldPattern[
    PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][ Tensor[x_,U1:{__},U2_] ,
      Tensor[x_,V__] ]]:=Module[{ind},
      ind=MapThread[FilterPD,MapAt[  Reverse[#]&,{{U1,U2},{V}},2],2];
      Times@@
        Map[Tensor[\[Delta],{#[[1]],Void},{Void,#[[2]]}]&,Transpose[ind]  ]
      ]/;(Count[
            ind=MapThread[FilterPD,MapAt[  Reverse[#]&,{{U1,U2},{V}},2],2],
            FilterPD[__],2]\[Equal]0)&&(And@@
          MapThread[(Head[#1]===Head[#2])&,Append[Transpose[ind],{1,2}]  ])


PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][Tensor[\[Delta]_,__],_]:=0



PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][
        Tensor[x_,{i_},{Void}],{___,Tensor[x_,{j_},{Void}],___,
          Tensor[x_,{k_},{Void}],___}]/;
      Head[i]===Head[j]\[And]Head[i]===Head[k]=0;



PartialD[labels_][   PartialD[labels_][    T_ , u_ ] , v_ ]:=
    PartialD[labels][   T ,Flatten[{v,u}] ];

PartialD[labels_][T_Times ,u_List]:=Fold[ PartialD[labels][  #1 ,#2 ]&,T,u];



HoldPattern[PartialD[lab_][ f_[g_],t_ List]
      ]:=Fold[Derivative[1][f][g]PartialD[lab][g,#]&,t]/;
      Not[MemberQ[{Tensor,TotalD,AbsoluteD,LieD,CovariantD,PVector},f]];

HoldPattern[PartialD[lab_][  F_[g_]  ,T_ ]]:=
    Derivative[1][F][g]*PartialD[lab][ g,T  ]/;
      Not[MemberQ[{Tensor,TotalD,AbsoluteD,LieD,CovariantD,PVector},F]];

HoldPattern[PartialD[lab_][  Power[g_,n_]  ,T_ ]]:=
  Derivative[1,0][Power][g,n]*PartialD[lab][ g,T  ]+
      Derivative[0,1][Power][g,n]*PartialD[lab][ n,T  ]/;Not[VectorQ[T]]

HoldPattern[PartialD[lab_][  Power[g_,n_]  ,{T_,S__}]]:=
  PartialD[lab][
    Derivative[1,0][Power][g,n]*PartialD[lab][ g,T  ]+
      Derivative[0,1][Power][g,n]*PartialD[lab][ n,T  ]
    ,{S}]

HoldPattern[ PartialD[lab_][ f_[g__],{t_,s__}] ]:= 
    PartialD[lab][   PartialD[lab][f[g],t]   ,{s}]/;
      Not[MemberQ[{Tensor,TotalD,AbsoluteD,LieD,CovariantD,PVector},f]]&&
        Not[MatchQ[f,PartialD[_]]];

HoldPattern[PartialD[lab_][ f_[g__],t_ ]
      ]:=Plus@@
        MapThread[
          Derivative[Sequence@@#1][f][g]PartialD[lab][#2,t]&,{IdentityMatrix[
              Length[{g}]],{g}}]/;
      Not[MemberQ[{Tensor,TotalD,AbsoluteD,LieD,CovariantD,PVector},f]]&&
        Not[MatchQ[f,PartialD[_]]]&&Not[VectorQ[t]];



NondependentPartialD[qin__?VectorQ][expr_]:=
  Module[{partialtest,q={qin}},
    
    partialtest[t_,partialsin_]:=
      Module[{partials,partiallabs},
        partials=If[Head[partialsin]===List,partialsin,{partialsin}];
        partiallabs=Cases[partials, Tensor[lab_,___]\[Rule]lab];
        
        Or@@(If[MemberQ[#,t],Intersection[Complement[#,{t}],partiallabs]=!={},
                  False]&/@q)
        ];
    
    expr/.PartialD[_][Tensor[t_,ind___],p_]/;partialtest[t,p]\[RuleDelayed]0
    ]





CovariantD[_?NumericQ,_]:=0;
CovariantD[w_Symbol,_]:=0;

(*Addition: 11/7/2003*)
CovariantD[w_,_]:=0/;Count[w,Tensor[__],{0,\[Infinity]}]===0

CovariantD[Tensor[T_,sup_,sub_],j_List]/;VectorQ[j]:=
    Module[{newup,newsub},
      newup=(Void&)/@j;
      newsub=Cov/@j;
      Tensor[T,Join[sup,newup],Join[sub,newsub]]];

CovariantD[Tensor[T_,sup_,sub_],j_]/;!VectorQ[j]:=
    Tensor[T,Join[sup,{Void}],Join[sub,{Cov[j]}]];



CovariantD[Tensor[T_],j_]/;!VectorQ[j]:=PartialD[Tensor[T],j];

CovariantD[Tensor[T_],{j_}]:=CovariantD[Tensor[T],j];

CovariantD[Tensor[T_],j_]/;VectorQ[j]:=Module[{ind1},
    ind1=First[j];
    CovariantD[ CovariantD[Tensor[T],ind1] ,  Drop[j,1] ]
    ]

CovariantD[w_Plus,j_]:=(CovariantD[#1,j]&)/@w;

CovariantD[w_ u_,j_]:=CovariantD[w,j] u+CovariantD[u,j] w/;VectorQ[j]==False;

CovariantD[w_ u_,j_List]:=Fold[CovariantD[#1,#2]&,w u,j];



ExpandCovariantD[labels_,dummy_][T_Plus]:=ExpandCovariantD[labels,dummy]/@T;

ExpandCovariantD[labels_,dummy_][T_*V_]:=
    T*ExpandCovariantD[labels,dummy][V]/;FreeCovQ[T];

ExpandCovariantD[labels_,{dummy1_,dummy2__}][T_*V_]:=
    ExpandCovariantD[labels,dummy1][T]*
        ExpandCovariantD[labels,{dummy2}][V]/;(Not[FreeCovQ[T]]&&
          Not[FreeCovQ[V]]);

ExpandCovariantD[labels_,{a_}][T_]:=ExpandCovariantD[labels,a][T];

ExpandCovariantD[__][  T_ ]:=T /;FreeCovQ[T];

GetCovIndices[Tensor[T_,sup_,sub_]]:=
    Module[{x,sub2,sub3},
      sub2=Cases[sub,Cov[_]];
      sub3=sub2/.\[InvisibleSpace]Cov[x_]\[Rule]x;
      If[Length[sub3]==1,Sequence@@sub3,sub3]];

DropCov[Tensor[T_,sup_,sub_]]:=
    Module[{indT},
      indT=
        Transpose[{sup,sub}]/.\[InvisibleSpace]{Void,Cov[_]}\[Rule]Sequence[];
      Tensor[T,Sequence@@Transpose[indT]]];

ChangeIndexToDummy[T_,{i_,Void},a_]:=T/.\[InvisibleSpace]i\[Rule]a;
ChangeIndexToDummy[T_,{Void,i_},a_]:=T/.\[InvisibleSpace]i\[Rule]a;
Null

ChristoffelFactor[{x_,g_,\[CapitalGamma]_},dummy_,DifInd_,{i_,Void}]:= 
    Tensor[\[CapitalGamma],{i,Void,Void},{Void,DifInd,dummy}];

ChristoffelFactor[{x_,g_,\[CapitalGamma]_},dummy_,
      DifInd_,{Void,
        i_}]:= -Tensor[\[CapitalGamma],{dummy,Void,Void},{Void,DifInd,i}];

ChristoffelTerms[{x_,g_,\[CapitalGamma]_},T_,dummy_,DifInd_,indt_]:=
    Module[{},
      Map[ ChangeIndexToDummy[T ,#,dummy]&,  indt ].Map[
          ChristoffelFactor[{x,g,\[CapitalGamma]},dummy,DifInd,#]&, indt]
      ];



ExpandCovariantD[{x_,\[Delta]_,g_,\[CapitalGamma]_},a_][ 
    Tensor[T_,{Void,Void},{Dif[i_],Cov[j_]}] 
    ]:=Module[{DTx},
    DTx=PartialD[{x,\[Delta],g,\[CapitalGamma]}][ Tensor[T] , 
        Tensor[x,{i},{Void}]  ];
    ExpandCovariantDXX[{x,\[Delta],g,\[CapitalGamma]}][{DTx,{Void},{i}},{j,
          a}]\[LeftDoubleBracket]1\[RightDoubleBracket]
    ]



ExpandCovariantD[{x_,\[Delta]_,g_,\[CapitalGamma]_},a_List][ 
    Tensor[T_,{Void..},ind:{Dif[i_],Cov[_]..}] 
    ]:=Module[{DTx,covi},
    covi=Drop[ind,1]/.Cov\[Rule]Sequence;
    indT=Transpose[{covi,a}];
    DTx=PartialD[{x,\[Delta],g,\[CapitalGamma]}][ Tensor[T] , 
        Tensor[x,{i},{Void}]  ];
    
    Fold[
        ExpandCovariantDXX[{x,\[Delta],
                g,\[CapitalGamma]}][#1,{#2[[1]],#2[[2]]}]&,
        {DTx,{Void},{i}},indT][[1]]
    ]



ExpandCovariantD[{x_,\[Delta]_,g_,\[CapitalGamma]_},a_][Tensor[T_,sup_,sub_]]:=
    
    Module[
        {CovInd,DropT,indt},
        CovInd=GetCovIndices[Tensor[T,sup,sub]];
        DropT=DropCov[Tensor[T,sup,sub]];
        indt=
          Transpose[{sup,sub}]/.\[InvisibleSpace]{Void,Cov[_]}\[Rule]
              Sequence[];
        PartialD[{x,\[Delta],g,\[CapitalGamma]}][DropT,
            Tensor[x,{CovInd},{Void}] ]+
          ChristoffelTerms[{x,g,\[CapitalGamma]},DropT,a,CovInd,
            indt]]/;!VectorQ[a];



ExpandCovariantD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][
      Tensor[T_,sup_,sub_]]:=
    Module[
        {CovInd,DropT,Dropsup,Dropsub},
        CovInd=GetCovIndices[Tensor[T,sup,sub]];
        DropT=DropCov[Tensor[T,sup,sub]];
        Dropsup=DropT\[LeftDoubleBracket]2\[RightDoubleBracket];
        Dropsub=DropT\[LeftDoubleBracket]3\[RightDoubleBracket];
        Fold[
            ExpandCovariantDXX[{x,\[Delta],g,\[CapitalGamma]}],{DropT,Dropsup,
              Dropsub},
            Transpose[{CovInd,
                dummy}]]\[LeftDoubleBracket]1\[RightDoubleBracket]]/;
      VectorQ[dummy];

ExpandCovariantDXX[{x_,\[Delta]_,g_,\[CapitalGamma]_}][{T_,sup_,
        sub_},{CovInd_,Dummy_}]:=
    Module[{indT},
      indT=Transpose[{sup,sub}];
      {PartialD[{x,\[Delta],g,\[CapitalGamma]}][T,Tensor[x,{CovInd},{Void}]]+
          ChristoffelTerms[{x,g,\[CapitalGamma]},T,Dummy,CovInd,indT],
        Append[sup,Void],Append[sub,CovInd ]}
      ];





TotalD[CircleTimes[args__],t__]:=
  Module[{n=Length[{args}],i},
    Sum[CircleTimes@@
        Join[Part[{args},Range[1,i-1]],{TotalD[Part[{args},i],t]},
          Part[{args},Range[i+1,n]]],{i,1,n}]]



TotalD[w_List,j_]:=(TotalD[#1,j]&)/@w;

TotalD[w_List]:=(TotalD[#1]&)/@w;

TotalD[w_Equal,j_]:=(TotalD[#1,j]&)/@w;

TotalD[w_Equal]:=(TotalD[#1]&)/@w;

TotalD[u_?NumericQ,___]:=0;

TotalD[u_,u_]:=1;

TotalD[u_Symbol,v___]:=0/;MemberQ[Attributes[u],Constant];

TotalD[w_Plus,j_]:=(TotalD[#1,j]&)/@w;

TotalD[w_Plus]:=(TotalD[#1]&)/@w;

TotalD[w_*u_,j_]:=TotalD[w,j] u+TotalD[u,j] w/;VectorQ[j]==False;

TotalD[w_*u_]:=TotalD[w] u+TotalD[u] w/;VectorQ[j]==False;

TotalD[w_?FreeTensorQ,t_]:=
    Dt[w,t]/;(Head[w]=!=PartialD)&&(Head[w]=!=TotalD)&&(Head[Head[w]]=!=
            PartialD)&&(Head[w]=!=PVector)&&Not[VectorQ[t]];

TotalD[CircleTimes[args__]]:=
  Module[{n=Length[{args}],i},
    Sum[CircleTimes@@
        Join[Part[{args},Range[1,i-1]],{TotalD[Part[{args},i]]},
          Part[{args},Range[i+1,n]]],{i,1,n}]]

TotalD[w_?FreeTensorQ]:=
    Dt[w]/;(Head[w]=!=PartialD)&&(Head[w]=!=TotalD)&&(Head[Head[w]]=!=
            PartialD)&&Not[VectorQ[t]];



TotalD[ Power[g_,n_],
      t_ ]:=(Derivative[ 1 ,0  ][Power][g,n]TotalD[ g,t]+
          Derivative[ 0 ,1  ][Power][g,n]TotalD[ n,t])/;Not[VectorQ[t]];

TotalD[ f_[g_],t_ ]:=
    Derivative[1][f][g]TotalD[g,t]/;
      f=!=Tensor&&f=!=PVector&&f=!=Times&&f=!=Plus&&f=!=TotalD&&
        Not[MatchQ[f,PartialD[_]]]&&Not[VectorQ[t]];

TotalD[ f_[g__],t_ ]:=
    Plus@@MapThread[
          Derivative[Sequence@@#1][f][g]TotalD[#2,t]&,{IdentityMatrix[
              Length[{g}]],{g}}]/;
      Not[MemberQ[{Tensor,Times,Plus,TotalD,AbsoluteD,LieD,PVector},f]]&&
        Not[MatchQ[f,PartialD[_]]]&&Not[VectorQ[t]];

TotalD[ f_[g_],t_ List]:=
    Fold[Derivative[1][f][g]TotalD[g,#]&,t]/;f=!=Tensor&&f=!=TotalD&&
      f=!=PVector&&Not[MatchQ[f,PartialD[_]]];



TotalD[w_*u_,j_List]:=Fold[ TotalD[#1,#2]&,w*u,j];

TotalD[   HoldPattern[TotalD[    T_ , u_ ]] , v_ ]:=
    TotalD[   T ,Flatten [{u,v}]  ];

TotalD[T_ ,u_List]:=Fold[  TotalD[  #1 ,#2 ]& ,T,u]/;Head[T]=!=Tensor;



ExpandTotalD[labels_,dummy_][T_Plus]:=ExpandTotalD[labels,dummy]/@T;

ExpandTotalD[labels_,dummy_][T_?NumericQ*V_]:=
    T* ExpandTotalD[labels,dummy][V];

ExpandTotalD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][    
      HoldPattern[TotalD[ Tensor[x_,ind__] ,t_]*V_]     ]:=
    TotalD[ Tensor[x,ind] ,t]* 
      ExpandTotalD[{x,\[Delta],g,\[CapitalGamma]},dummy][V];

ExpandTotalD[labels_,dummy_][T_*V_]:=
    T* ExpandTotalD[labels,dummy][V]/;FreeTotalDQ[T];

ExpandTotalD[labels_,dummy_][T_]:=T/;FreeTotalDQ[T];

ExpandTotalD[labels_,{a_,dummy_}][T_*V_]:=
    ExpandTotalD[labels,a][T]*ExpandTotalD[labels,{dummy}][V]/;
      Not[FreeTotalDQ[T]]&&Not[FreeTotalDQ[V]];

ExpandTotalD[x_,{a_}][T_]:=ExpandTotalD[x,a][T];

ExpandTotalD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][   
      HoldPattern[TotalD[T_,v_]]   ]:=
    PartialD[{x,\[Delta],g,\[CapitalGamma]}][T,Tensor[x,{dummy},{Void}]]*
        TotalD[ Tensor[x,{dummy},{Void}]  ,v]/;
      Not[VectorQ[v]]&&Not[VectorQ[dummy]];

ExpandTotalD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][   
      HoldPattern[TotalD[T_]]   ]:=
    PartialD[{x,\[Delta],g,\[CapitalGamma]}][T,Tensor[x,{dummy},{Void}] ]*
        TotalD[ Tensor[x,{dummy},{Void}]  ]/;
      Not[VectorQ[v]]&&Not[VectorQ[dummy]];

ExpandTotalD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_List][   
      HoldPattern[TotalD[T_,v_List]]   ]:=Module[{DummyParam},
      If[Length[dummy]=!=Length[v],Print["Wrong number of dummies"]];
      DummyParam= Transpose[{dummy,v}] ;
      Fold[
        ExpandTotalD[{x,\[Delta],g,\[CapitalGamma]}, #2[[1]]   ][     
            TotalD[#1,#2[[2]]]     ]&,T , DummyParam ]
      ];





AbsoluteD[u_?NumericQ,_]:=0;



AbsoluteD[u_?FreeTensorQ,t_]/;FreeQ[u,Alternatives@@t]:=0

AbsoluteD[w_Plus,j_]:=(AbsoluteD[#1,j]&)/@w;

AbsoluteD[w_*u_,j_]:=AbsoluteD[w,j] u+AbsoluteD[u,j] w/;VectorQ[j]==False;

AbsoluteD[ Tensor[F_],t_]:=TotalD[Tensor[F],t];



HoldPattern[AbsoluteD[ TotalD[F_,t_],v_]]:=
    TotalD[Tensor[F],Sort@Flatten[{t,v}]];



AbsoluteD[w_*u_,j_List]:=Fold[ AbsoluteD[#1,#2]&,w*u,j];

AbsoluteD[   AbsoluteD[T_ , u_ ] , v_ ]:=AbsoluteD[   T ,Flatten [{u,v}]  ];

AbsoluteD[T_ ,u_List]:=Fold[  AbsoluteD[  #1 ,#2 ]& ,T,u]/;Head[T]=!=Tensor;



ExpandAbsoluteD[labels_,dummy_][T_Plus]:=ExpandAbsoluteD[labels,dummy]/@T;

ExpandAbsoluteD[labels_,dummy_][T_?NumericQ*V_]:=
    T* ExpandAbsoluteD[labels,dummy][V];

ExpandAbsoluteD[labels_,{dummy1_,dummy2__}][TotalD[T__]*V_]:=
    TotalD[T]*ExpandAbsoluteD[labels,{dummy2}][V]/;Not[FreeAbsoluteDQ[V]];

ExpandAbsoluteD[labels_,dummy_][T_*V_]:=
    T* ExpandAbsoluteD[labels,dummy][V]/;FreeAbsoluteDQ[T];

ExpandAbsoluteD[labels,dummy_][T_]:=T/;FreeAbsoluteDQ[T];

ExpandAbsoluteD[labels_,{dummy1_,dummy2__}][T_*V_]:=
    ExpandAbsoluteD[labels,dummy1][T]*ExpandAbsoluteD[labels,{dummy2}][V]/;
      Not[FreeAbsoluteDQ[T]]&&Not[FreeAbsoluteDQ[V]];

ExpandAbsoluteD[labels_,{{a_,b_}}][T_]:=ExpandAbsoluteD[labels,{a,b}][T];







ExpandAbsoluteD[{x_,\[Delta]_,g_,\[CapitalGamma]_},{a_,CovInd_}][   
      AbsoluteD[Tensor[T_,sup_,sub_],t_]   ]:=
    Module[
        {indt},
        indt=Transpose[{sup,sub}];
        TotalD[Tensor[T,sup,sub],t]+
          
          ChristoffelTerms[{x,g,\[CapitalGamma]},Tensor[T,sup,sub],CovInd,a,
              indt]*TotalD[Tensor[x,{a},{Void}],t]
        ]/;!VectorQ[t];

ExpandAbsoluteD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][   
    AbsoluteD[Tensor[T_,sup_,sub_] ,t_]]:=
  Module[{dct},
      dct=MapThread[Append,{dummy,t}];
      Fold[
          ExpandAbsoluteDXX[{x,\[Delta],g,\[CapitalGamma]}]  
          ,{Tensor[T,sup,sub],sup,sub}
          ,dct]\[LeftDoubleBracket]1\[RightDoubleBracket]
      ]/;VectorQ[t]







ExpandAbsoluteDXX[{x_,\[Delta]_,g_,\[CapitalGamma]_}][{T_,sup_,sub_},{Dummy_,
        CovInd_,t_}]:=
    Module[{indT},
      indT=Transpose[{sup,sub}];
      { TotalD[T,t]+
          ChristoffelTerms[{x,g,\[CapitalGamma]},T,CovInd,Dummy,indT]*
            TotalD[Tensor[x,{Dummy},{Void}],t],sup,sub}];



ExpandAbsoluteD[_,_][HoldPattern[totd:TotalD[_,_]]]:=totd



LieD[T_Plus,V_] := Map[ LieD[#,V]& , T ];

LieD[u_?NumericQ,__]:=0;

LieD[u_Symbol,_]:=0;

LieD[w_Plus,V_]:=(LieD[#1,V]&)/@w;

LieD[w_*u_,V_]:=LieD[w,V] *u+LieD[u,V]* w/;Not[VectorQ[V]];



LieD[w_*u_,V_List]:=Fold[  LieD[#1,#2]&,w*u,V];

LieD[   LieD[T_ , U_] , V_ ]:=LieD[   T ,   Flatten[{U,V}]  ];

LieD[T_ ,U_List]:=Fold[  LieD[  #1 ,#2 ]& ,T,U]/;Head[T]=!=Tensor;



ExpandLieD[x_,dummy_][T_Plus]:=ExpandLieD[x,dummy]/@T;

ExpandLieD[x_,dummy_][T_?NumericQ*V_]:=T* ExpandLieD[x,dummy][V];

ExpandLieD[x_,dummy_][T_*V_]:=T* ExpandLieD[x,dummy][V]/;FreeLieDQ[T];

ExpandLieD[x_,dummy_][T_]:=T/;FreeLieDQ[T];

ExpandLieD[x_,{dummy1_,dummy2__}][T_*V_]:=
    ExpandLieD[x,dummy1][T]*ExpandLieD[x,{dummy2}][V]/;
      Not[FreeLieDQ[T]]&&Not[FreeLieDQ[V]];

ExpandLieD[x_,{a_}][T_]:=ExpandLieD[x,a][T];



PartialDFieldV[{x_,\[Delta]_,g_,\[CapitalGamma]_},V_,dummy_][{i_,
        Void}]:=-PartialD[{x,\[Delta],g,\[CapitalGamma]}][  
        Tensor[V,{i},{Void}],Tensor[x,{dummy},{Void}]];

PartialDFieldV[{x_,\[Delta]_,g_,\[CapitalGamma]_},V_,dummy_][{Void,i_}]:=
    PartialD[{x,\[Delta],g,\[CapitalGamma]}][   Tensor[V,{dummy},{Void}],
      Tensor[x,{i},{Void}]];

ExpandLieD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][      
    LieD[Tensor[T_,sup_,sub_],V_]    ]:=Module[{indT},
      indT=Transpose[{sup,sub}];
      PartialD[{x,\[Delta],g,\[CapitalGamma]}][Tensor[T,sup,sub],
            Tensor[x,{dummy},{Void}]]*Tensor[V,{dummy},{Void}]+
        Map[ChangeIndexToDummy[Tensor[T,sup,sub],#,dummy]& ,  indT].
          Map[PartialDFieldV[{x,\[Delta],g,\[CapitalGamma]},V,dummy],indT]
      
      ]/;Not[VectorQ[V]]

ExpandLieD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][      
    LieD[Tensor[T_,sup_,sub_],V_]    ]:=Module[{indT,dumV},
      indT=Transpose[{sup,sub}];
      dumV=Transpose[{dummy,V}];
      
      Fold[
        Function[{Tens,dummyV},
            
            PartialD[{x,\[Delta],g,\[CapitalGamma]}][ Tens,
                  Tensor[x,{dummyV\[LeftDoubleBracket]1\[RightDoubleBracket]},\
{Void}] ]*Tensor[
                  dummyV\[LeftDoubleBracket]2\[RightDoubleBracket],{dummyV\
\[LeftDoubleBracket]1\[RightDoubleBracket]},{Void}]+
              
              Map[ChangeIndexToDummy[Tens,#,
                      dummyV\[LeftDoubleBracket]1\[RightDoubleBracket]]& ,  
                  indT].
                
                Map[PartialDFieldV[{x,\[Delta],g,\[CapitalGamma]},
                    dummyV\[LeftDoubleBracket]2\[RightDoubleBracket],
                    dummyV\[LeftDoubleBracket]1\[RightDoubleBracket]],indT]]
          ,
          Tensor[T,sup,sub],dumV]
      
      ]/;VectorQ[V]

ExpandLieD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][      
    LieD[Tensor[\[Phi]_],V_]    ]:=Module[{},
      PartialD[{x,\[Delta],g,\[CapitalGamma]}][ Tensor[\[Phi]],
          Tensor[x,{dummy},{Void}] ]*Tensor[V,{dummy},{Void}]
      ]/;Not[VectorQ[V]]

ExpandLieD[{x_,\[Delta]_,g_,\[CapitalGamma]_},dummy_][      
    LieD[Tensor[\[Phi]_],V_]    ]:=Module[{dumV},
      dumV=Transpose[{dummy,V}];
      
      Fold[
        Function[{Tens,dummyV},
            
            PartialD[{x,\[Delta],g,\[CapitalGamma]}][ Tens,
                Tensor[x,{dummyV\[LeftDoubleBracket]1\[RightDoubleBracket]},{\
Void} ]]*Tensor[
                dummyV\[LeftDoubleBracket]2\[RightDoubleBracket],{dummyV\
\[LeftDoubleBracket]1\[RightDoubleBracket]},{Void}]]
          ,Tensor[\[Phi]],dumV]
      
      ]/;VectorQ[V]



FreeTensorQ[w_]:= Position[w,Tensor]=={};

FreeCovQ[w_]:= Position[w,Cov]=={};

FreeTotalDQ[w_]:= Position[w,TotalD]=={};

FreeAbsoluteDQ[w_]:= Position[w,AbsoluteD]=={};

FreeLieDQ[w_]:= Position[w,LieD]=={};



End[]



DeclareBaseIndices[{1,2,3}];

SetDerivativeSymbols[{",",";","\[DifferentialD]","\[DifferentialD]","D","d",
    ""}]

Off[General::spell]
Off[General::spell1];

EndPackage[]