(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     15362,        562]*)
(*NotebookOutlinePosition[     27298,        921]*)
(*  CellTagsIndexPosition[     24457,        835]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["Master Index Entries for Tensorial", "Chapter"],

Cell["Tensorial Package", "IndexSection",
  CellTags->"MasterIndexHeading"],

Cell[CellGroupData[{

Cell["Tensorial", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["Tensor",
      ButtonData:>{"Tensor"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Tensor"],

Cell[BoxData[
    ButtonBox["CircleTimes",
      ButtonData:>{"CircleTimes"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Tensor"],

Cell[BoxData[
    ButtonBox["SetTensorValues",
      ButtonData:>{"SetTensorValues"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SetTensorValues"],

Cell[BoxData[
    ButtonBox["SetTensorValueRules",
      ButtonData:>{"SetTensorValueRules"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SetTensorValueRules"],

Cell[BoxData[
    ButtonBox["TensorValueRules",
      ButtonData:>{"TensorValueRules"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"TensorValueRules"],

Cell[BoxData[
    ButtonBox["ClearTensorValues",
      ButtonData:>{"ClearTensorValues"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ClearTensorValues"],

Cell[BoxData[
    ButtonBox["DeclareZeroTensor",
      ButtonData:>{"DeclareZeroTensor"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DeclareZeroTensor"],

Cell[BoxData[
    ButtonBox["NonzeroValueRules",
      ButtonData:>{"NonzeroValueRules"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"NonzeroValueRules"],

Cell[BoxData[
    ButtonBox["DefineTensorShortcuts",
      ButtonData:>{"DefineTensorShortcuts"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DefineTensorShortcuts"],

Cell[BoxData[
    ButtonBox["ClearTensorShortcuts",
      ButtonData:>{"ClearTensorShortcuts"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ClearTensorShortcuts"],

Cell[BoxData[
    ButtonBox["Void",
      ButtonData:>{"Void"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Void"],

Cell[BoxData[
    ButtonBox["Cov",
      ButtonData:>{"Cov"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Cov"],

Cell[BoxData[
    ButtonBox["Dif",
      ButtonData:>{"Dif"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Cov"],

Cell[BoxData[
    ButtonBox["BaseIndices",
      ButtonData:>{"BaseIndices"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"BaseIndices"],

Cell[BoxData[
    ButtonBox["DeclareBaseIndices",
      ButtonData:>{"DeclareBaseIndices"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DeclareBaseIndices"],

Cell[BoxData[
    ButtonBox["NDim",
      ButtonData:>{"NDim"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"NDim"],

Cell[BoxData[
    ButtonBox["BaseIndexQ",
      ButtonData:>{"BaseIndexQ"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"BaseIndexQ"],

Cell[BoxData[
    ButtonBox["MetricSimplify",
      ButtonData:>{"MetricSimplify"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"MetricSimplify"],

Cell[BoxData[
    ButtonBox["RawIndex",
      ButtonData:>{"RawIndex"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"RawIndex"],

Cell[BoxData[
    ButtonBox["SymbolicIndexQ",
      ButtonData:>{"SymbolicIndexQ"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SymbolicIndexQ"],

Cell[BoxData[
    ButtonBox["ExtractFreeIndices",
      ButtonData:>{"ExtractFreeIndices"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ExtractFreeIndices"],

Cell[BoxData[
    ButtonBox["RaiseIndex",
      ButtonData:>{"RaiseIndex"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"RaiseIndex"],

Cell[BoxData[
    ButtonBox["LowerIndex",
      ButtonData:>{"LowerIndex"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"LowerIndex"],

Cell[BoxData[
    ButtonBox["ReplaceIndex",
      ButtonData:>{"ReplaceIndex"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ReplaceIndex"],

Cell[BoxData[
    ButtonBox["IndexFlavors",
      ButtonData:>{"IndexFlavors"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"IndexFlavors"],

Cell[BoxData[
    ButtonBox["DeclareIndexFlavor",
      ButtonData:>{"DeclareIndexFlavor"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DeclareIndexFlavor"],

Cell[BoxData[
    ButtonBox["ClearIndexFlavor",
      ButtonData:>{"ClearIndexFlavor"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ClearIndexFlavor"],

Cell[BoxData[
    ButtonBox["ToFlavor",
      ButtonData:>{"ToFlavor"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ToFlavor"],

Cell[BoxData[
    ButtonBox["IndexFlavorQ",
      ButtonData:>{"IndexFlavorQ"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"IndexFlavorQ"],

Cell[BoxData[
    ButtonBox["UseCoordinates",
      ButtonData:>{"UseCoordinates"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"UseCoordinates"],

Cell[BoxData[
    ButtonBox["CoordinatesToTensors",
      ButtonData:>{"CoordinatesToTensors"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CoordinatesToTensors"],

Cell[BoxData[
    ButtonBox["ArrayExpansion",
      ButtonData:>{"ArrayExpansion"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ArrayExpansion"],

Cell[BoxData[
    ButtonBox["SumExpansion",
      ButtonData:>{"SumExpansion"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SumExpansion"],

Cell[BoxData[
    ButtonBox["EinsteinSum",
      ButtonData:>{"EinsteinSum"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"EinsteinSum"],

Cell[BoxData[
    ButtonBox["EinsteinArray",
      ButtonData:>{"EinsteinArray"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"EinsteinArray"],

Cell[BoxData[
    ButtonBox["PartialSum",
      ButtonData:>{"PartialSum"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PartialSum"],

Cell[BoxData[
    ButtonBox["PartialArray",
      ButtonData:>{"PartialArray"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PartialArray"],

Cell[BoxData[
    ButtonBox["IndexChange",
      ButtonData:>{"IndexChange"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"IndexChange"],

Cell[BoxData[
    ButtonBox["UpDownSwap",
      ButtonData:>{"UpDownSwap"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"UpDownSwap"],

Cell[BoxData[
    ButtonBox["Symmetric",
      ButtonData:>{"Symmetric"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Symmetric"],

Cell[BoxData[
    ButtonBox["AntiSymmetric",
      ButtonData:>{"AntiSymmetric"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"AntiSymmetric"],

Cell[BoxData[
    ButtonBox["DummySimplify",
      ButtonData:>{"DummySimplify"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DummySimplify"],

Cell[BoxData[
    ButtonBox["SimplifyTensorSum",
      ButtonData:>{"SimplifyTensorSum"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SimplifyTensorSum"],

Cell[BoxData[
    ButtonBox["MapLevelParts",
      ButtonData:>{"MapLevelParts"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"MapLevelParts"],

Cell[BoxData[
    ButtonBox["ParseTermIndices",
      ButtonData:>{"ParseTermIndices"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ParseTermIndices"],

Cell[BoxData[
    ButtonBox["PartialD",
      ButtonData:>{"PartialD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PartialD"],

Cell[BoxData[
    ButtonBox["ExpandPartialD",
      ButtonData:>{"ExpandPartialD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ExpandPartialD"],

Cell[BoxData[
    ButtonBox["NondependentPartialD",
      ButtonData:>{"NondependentPartialD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"NondependentPartialD"],

Cell[BoxData[
    ButtonBox["CovariantD",
      ButtonData:>{"CovariantD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CovariantD"],

Cell[BoxData[
    ButtonBox["ExpandCovariantD",
      ButtonData:>{"ExpandCovariantD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ExpandCovariantD"],

Cell[BoxData[
    ButtonBox["TotalD",
      ButtonData:>{"TotalD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"TotalD"],

Cell[BoxData[
    ButtonBox["ExpandTotalD",
      ButtonData:>{"ExpandTotalD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ExpandTotalD"],

Cell[BoxData[
    ButtonBox["AbsoluteD",
      ButtonData:>{"AbsoluteD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"AbsoluteD"],

Cell[BoxData[
    ButtonBox["ExpandAbsoluteD",
      ButtonData:>{"ExpandAbsoluteD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ExpandAbsoluteD"],

Cell[BoxData[
    ButtonBox["LieD",
      ButtonData:>{"LieD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"LieD"],

Cell[BoxData[
    ButtonBox["ExpandLieD",
      ButtonData:>{"ExpandLieD"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ExpandLieD"],

Cell[BoxData[
    ButtonBox["SetMetricValues",
      ButtonData:>{"SetMetricValues"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SetMetricValues"],

Cell[BoxData[
    ButtonBox["SetMetricValueRules",
      ButtonData:>{"SetMetricValueRules"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SetMetricValueRules"],

Cell[BoxData[
    ButtonBox["CalculateChristoffelu",
      ButtonData:>{"CalculateChristoffelu"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CalculateChristoffelu"],

Cell[BoxData[
    ButtonBox["CalculateChristoffeld",
      ButtonData:>{"CalculateChristoffeld"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CalculateChristoffeld"],

Cell[BoxData[
    ButtonBox["SetChristoffelValues",
      ButtonData:>{"SetChristoffelValues"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SetChristoffelValues"],

Cell[BoxData[
    ButtonBox["SetChristoffelValueRules",
      ButtonData:>{"SetChristoffelValueRules"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SetChristoffelValueRules"],

Cell[BoxData[
    ButtonBox["BasisDotProductRules",
      ButtonData:>{"BasisDotProductRules"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"BasisDotProductRules"],

Cell[BoxData[
    ButtonBox["ReverseBasisDotProductRules",
      ButtonData:>{"ReverseBasisDotProductRules"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ReverseBasisDotProductRules"],

Cell[BoxData[
    ButtonBox["EvaluateDotProducts",
      ButtonData:>{"EvaluateDotProducts"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"EvaluateDotProducts"],

Cell[BoxData[
    ButtonBox["CircleEvalRule",
      ButtonData:>{"CircleEvalRule"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CircleEvalRule"],

Cell[BoxData[
    ButtonBox["ConstructDirectProduct",
      ButtonData:>{"ConstructDirectProduct"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ConstructDirectProduct"],

Cell[BoxData[
    ButtonBox["UsePartialDChainRule",
      ButtonData:>{"UsePartialDChainRule"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"UsePartialDChainRule"],

Cell[BoxData[
    ButtonBox["UseTotalDChainRule",
      ButtonData:>{"UseTotalDChainRule"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"UseTotalDChainRule"],

Cell[BoxData[
    ButtonBox["ContractArray",
      ButtonData:>{"ContractArray"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ContractArray"],

Cell[BoxData[
    ButtonBox["ToArrayValues",
      ButtonData:>{"ToArrayValues"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ToArrayValues"],

Cell[BoxData[
    ButtonBox["ContractKroneckers",
      ButtonData:>{"ContractKroneckers"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ContractKroneckers"],

Cell[BoxData[
    ButtonBox["EvaluateSlots",
      ButtonData:>{"EvaluateSlots"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"EvaluateSlots"],

Cell[BoxData[
    ButtonBox["FullKroneckerExpand",
      ButtonData:>{"FullKroneckerExpand"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"FullKroneckerExpand"],

Cell[BoxData[
    ButtonBox["GenerateBasisTensors",
      ButtonData:>{"GenerateBasisTensors"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"GenerateBasisTensors"],

Cell[BoxData[
    ButtonBox["KroneckerAbsorb",
      ButtonData:>{"KroneckerAbsorb"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"KroneckerAbsorb"],

Cell[BoxData[
    ButtonBox["PermutationPseudotensor",
      ButtonData:>{"PermutationPseudotensor"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PermutationPseudotensor"],

Cell[BoxData[
    ButtonBox["PermutationSymbolRules",
      ButtonData:>{"PermutationSymbolRules"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PermutationPseudotensor"],

Cell[BoxData[
    ButtonBox["LeviCivitaDefinition3D",
      ButtonData:>{"LeviCivitaDefinition3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"LeviCivitaDefinition3D"],

Cell[BoxData[
    ButtonBox["LinearBreakout",
      ButtonData:>{"LinearBreakout"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"LinearBreakout"],

Cell[BoxData[
    ButtonBox["PartialKroneckerExpand",
      ButtonData:>{"PartialKroneckerExpand"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PartialKroneckerExpand"],

Cell[BoxData[
    ButtonBox["PushOnto",
      ButtonData:>{"PushOnto"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PushOnto"],

Cell[BoxData[
    ButtonBox["SymmetrizeSlots",
      ButtonData:>{"SymmetrizeSlots"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SymmetrizeSlots"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 943}},
ScreenStyleEnvironment->"Brackets",
WindowToolbars->"EditBar",
CellGrouping->Manual,
WindowSize->{448, 728},
WindowMargins->{{6, Automatic}, {Automatic, 0}},
ShowCellBracket->True,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "MasterIndexHeading"->{
    Cell[1810, 53, 75, 1, 42, "IndexSection",
      CellTags->"MasterIndexHeading"]},
  "Tensor"->{
    Cell[1968, 62, 133, 4, 17, "Index",
      CellTags->"Tensor"],
    Cell[2104, 68, 143, 4, 17, "Index",
      CellTags->"Tensor"]},
  "SetTensorValues"->{
    Cell[2250, 74, 160, 4, 17, "Index",
      CellTags->"SetTensorValues"]},
  "SetTensorValueRules"->{
    Cell[2413, 80, 172, 4, 17, "Index",
      CellTags->"SetTensorValueRules"]},
  "TensorValueRules"->{
    Cell[2588, 86, 163, 4, 17, "Index",
      CellTags->"TensorValueRules"]},
  "ClearTensorValues"->{
    Cell[2754, 92, 166, 4, 17, "Index",
      CellTags->"ClearTensorValues"]},
  "DeclareZeroTensor"->{
    Cell[2923, 98, 166, 4, 17, "Index",
      CellTags->"DeclareZeroTensor"]},
  "NonzeroValueRules"->{
    Cell[3092, 104, 166, 4, 17, "Index",
      CellTags->"NonzeroValueRules"]},
  "DefineTensorShortcuts"->{
    Cell[3261, 110, 178, 4, 17, "Index",
      CellTags->"DefineTensorShortcuts"]},
  "ClearTensorShortcuts"->{
    Cell[3442, 116, 175, 4, 17, "Index",
      CellTags->"ClearTensorShortcuts"]},
  "Void"->{
    Cell[3620, 122, 127, 4, 17, "Index",
      CellTags->"Void"]},
  "Cov"->{
    Cell[3750, 128, 124, 4, 17, "Index",
      CellTags->"Cov"],
    Cell[3877, 134, 124, 4, 17, "Index",
      CellTags->"Cov"]},
  "BaseIndices"->{
    Cell[4004, 140, 148, 4, 17, "Index",
      CellTags->"BaseIndices"]},
  "DeclareBaseIndices"->{
    Cell[4155, 146, 169, 4, 17, "Index",
      CellTags->"DeclareBaseIndices"]},
  "NDim"->{
    Cell[4327, 152, 127, 4, 17, "Index",
      CellTags->"NDim"]},
  "BaseIndexQ"->{
    Cell[4457, 158, 145, 4, 17, "Index",
      CellTags->"BaseIndexQ"]},
  "MetricSimplify"->{
    Cell[4605, 164, 157, 4, 17, "Index",
      CellTags->"MetricSimplify"]},
  "RawIndex"->{
    Cell[4765, 170, 139, 4, 17, "Index",
      CellTags->"RawIndex"]},
  "SymbolicIndexQ"->{
    Cell[4907, 176, 157, 4, 17, "Index",
      CellTags->"SymbolicIndexQ"]},
  "ExtractFreeIndices"->{
    Cell[5067, 182, 169, 4, 17, "Index",
      CellTags->"ExtractFreeIndices"]},
  "RaiseIndex"->{
    Cell[5239, 188, 145, 4, 17, "Index",
      CellTags->"RaiseIndex"]},
  "LowerIndex"->{
    Cell[5387, 194, 145, 4, 17, "Index",
      CellTags->"LowerIndex"]},
  "ReplaceIndex"->{
    Cell[5535, 200, 151, 4, 17, "Index",
      CellTags->"ReplaceIndex"]},
  "IndexFlavors"->{
    Cell[5689, 206, 151, 4, 17, "Index",
      CellTags->"IndexFlavors"]},
  "DeclareIndexFlavor"->{
    Cell[5843, 212, 169, 4, 17, "Index",
      CellTags->"DeclareIndexFlavor"]},
  "ClearIndexFlavor"->{
    Cell[6015, 218, 163, 4, 17, "Index",
      CellTags->"ClearIndexFlavor"]},
  "ToFlavor"->{
    Cell[6181, 224, 139, 4, 17, "Index",
      CellTags->"ToFlavor"]},
  "IndexFlavorQ"->{
    Cell[6323, 230, 151, 4, 17, "Index",
      CellTags->"IndexFlavorQ"]},
  "UseCoordinates"->{
    Cell[6477, 236, 157, 4, 17, "Index",
      CellTags->"UseCoordinates"]},
  "CoordinatesToTensors"->{
    Cell[6637, 242, 175, 4, 17, "Index",
      CellTags->"CoordinatesToTensors"]},
  "ArrayExpansion"->{
    Cell[6815, 248, 157, 4, 17, "Index",
      CellTags->"ArrayExpansion"]},
  "SumExpansion"->{
    Cell[6975, 254, 151, 4, 17, "Index",
      CellTags->"SumExpansion"]},
  "EinsteinSum"->{
    Cell[7129, 260, 148, 4, 17, "Index",
      CellTags->"EinsteinSum"]},
  "EinsteinArray"->{
    Cell[7280, 266, 154, 4, 17, "Index",
      CellTags->"EinsteinArray"]},
  "PartialSum"->{
    Cell[7437, 272, 145, 4, 17, "Index",
      CellTags->"PartialSum"]},
  "PartialArray"->{
    Cell[7585, 278, 151, 4, 17, "Index",
      CellTags->"PartialArray"]},
  "IndexChange"->{
    Cell[7739, 284, 148, 4, 17, "Index",
      CellTags->"IndexChange"]},
  "UpDownSwap"->{
    Cell[7890, 290, 145, 4, 17, "Index",
      CellTags->"UpDownSwap"]},
  "Symmetric"->{
    Cell[8038, 296, 142, 4, 17, "Index",
      CellTags->"Symmetric"]},
  "AntiSymmetric"->{
    Cell[8183, 302, 154, 4, 17, "Index",
      CellTags->"AntiSymmetric"]},
  "DummySimplify"->{
    Cell[8340, 308, 154, 4, 17, "Index",
      CellTags->"DummySimplify"]},
  "SimplifyTensorSum"->{
    Cell[8497, 314, 166, 4, 17, "Index",
      CellTags->"SimplifyTensorSum"]},
  "MapLevelParts"->{
    Cell[8666, 320, 154, 4, 17, "Index",
      CellTags->"MapLevelParts"]},
  "ParseTermIndices"->{
    Cell[8823, 326, 163, 4, 17, "Index",
      CellTags->"ParseTermIndices"]},
  "PartialD"->{
    Cell[8989, 332, 139, 4, 17, "Index",
      CellTags->"PartialD"]},
  "ExpandPartialD"->{
    Cell[9131, 338, 157, 4, 17, "Index",
      CellTags->"ExpandPartialD"]},
  "NondependentPartialD"->{
    Cell[9291, 344, 175, 4, 17, "Index",
      CellTags->"NondependentPartialD"]},
  "CovariantD"->{
    Cell[9469, 350, 145, 4, 17, "Index",
      CellTags->"CovariantD"]},
  "ExpandCovariantD"->{
    Cell[9617, 356, 163, 4, 17, "Index",
      CellTags->"ExpandCovariantD"]},
  "TotalD"->{
    Cell[9783, 362, 133, 4, 17, "Index",
      CellTags->"TotalD"]},
  "ExpandTotalD"->{
    Cell[9919, 368, 151, 4, 17, "Index",
      CellTags->"ExpandTotalD"]},
  "AbsoluteD"->{
    Cell[10073, 374, 142, 4, 17, "Index",
      CellTags->"AbsoluteD"]},
  "ExpandAbsoluteD"->{
    Cell[10218, 380, 160, 4, 17, "Index",
      CellTags->"ExpandAbsoluteD"]},
  "LieD"->{
    Cell[10381, 386, 127, 4, 17, "Index",
      CellTags->"LieD"]},
  "ExpandLieD"->{
    Cell[10511, 392, 145, 4, 17, "Index",
      CellTags->"ExpandLieD"]},
  "SetMetricValues"->{
    Cell[10659, 398, 160, 4, 17, "Index",
      CellTags->"SetMetricValues"]},
  "SetMetricValueRules"->{
    Cell[10822, 404, 172, 4, 17, "Index",
      CellTags->"SetMetricValueRules"]},
  "CalculateChristoffelu"->{
    Cell[10997, 410, 178, 4, 17, "Index",
      CellTags->"CalculateChristoffelu"]},
  "CalculateChristoffeld"->{
    Cell[11178, 416, 178, 4, 17, "Index",
      CellTags->"CalculateChristoffeld"]},
  "SetChristoffelValues"->{
    Cell[11359, 422, 175, 4, 17, "Index",
      CellTags->"SetChristoffelValues"]},
  "SetChristoffelValueRules"->{
    Cell[11537, 428, 187, 4, 17, "Index",
      CellTags->"SetChristoffelValueRules"]},
  "BasisDotProductRules"->{
    Cell[11727, 434, 175, 4, 17, "Index",
      CellTags->"BasisDotProductRules"]},
  "ReverseBasisDotProductRules"->{
    Cell[11905, 440, 196, 4, 17, "Index",
      CellTags->"ReverseBasisDotProductRules"]},
  "EvaluateDotProducts"->{
    Cell[12104, 446, 172, 4, 17, "Index",
      CellTags->"EvaluateDotProducts"]},
  "CircleEvalRule"->{
    Cell[12279, 452, 157, 4, 17, "Index",
      CellTags->"CircleEvalRule"]},
  "ConstructDirectProduct"->{
    Cell[12439, 458, 181, 4, 17, "Index",
      CellTags->"ConstructDirectProduct"]},
  "UsePartialDChainRule"->{
    Cell[12623, 464, 175, 4, 17, "Index",
      CellTags->"UsePartialDChainRule"]},
  "UseTotalDChainRule"->{
    Cell[12801, 470, 169, 4, 17, "Index",
      CellTags->"UseTotalDChainRule"]},
  "ContractArray"->{
    Cell[12973, 476, 154, 4, 17, "Index",
      CellTags->"ContractArray"]},
  "ToArrayValues"->{
    Cell[13130, 482, 154, 4, 17, "Index",
      CellTags->"ToArrayValues"]},
  "ContractKroneckers"->{
    Cell[13287, 488, 169, 4, 17, "Index",
      CellTags->"ContractKroneckers"]},
  "EvaluateSlots"->{
    Cell[13459, 494, 154, 4, 17, "Index",
      CellTags->"EvaluateSlots"]},
  "FullKroneckerExpand"->{
    Cell[13616, 500, 172, 4, 17, "Index",
      CellTags->"FullKroneckerExpand"]},
  "GenerateBasisTensors"->{
    Cell[13791, 506, 175, 4, 17, "Index",
      CellTags->"GenerateBasisTensors"]},
  "KroneckerAbsorb"->{
    Cell[13969, 512, 160, 4, 17, "Index",
      CellTags->"KroneckerAbsorb"]},
  "PermutationPseudotensor"->{
    Cell[14132, 518, 184, 4, 17, "Index",
      CellTags->"PermutationPseudotensor"],
    Cell[14319, 524, 182, 4, 17, "Index",
      CellTags->"PermutationPseudotensor"]},
  "LeviCivitaDefinition3D"->{
    Cell[14504, 530, 181, 4, 17, "Index",
      CellTags->"LeviCivitaDefinition3D"]},
  "LinearBreakout"->{
    Cell[14688, 536, 157, 4, 17, "Index",
      CellTags->"LinearBreakout"]},
  "PartialKroneckerExpand"->{
    Cell[14848, 542, 181, 4, 17, "Index",
      CellTags->"PartialKroneckerExpand"]},
  "PushOnto"->{
    Cell[15032, 548, 139, 4, 17, "Index",
      CellTags->"PushOnto"]},
  "SymmetrizeSlots"->{
    Cell[15174, 554, 160, 4, 17, "Index",
      CellTags->"SymmetrizeSlots"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"MasterIndexHeading", 16110, 582},
  {"Tensor", 16210, 585},
  {"SetTensorValues", 16368, 590},
  {"SetTensorValueRules", 16472, 593},
  {"TensorValueRules", 16577, 596},
  {"ClearTensorValues", 16680, 599},
  {"DeclareZeroTensor", 16784, 602},
  {"NonzeroValueRules", 16888, 605},
  {"DefineTensorShortcuts", 16997, 608},
  {"ClearTensorShortcuts", 17109, 611},
  {"Void", 17204, 614},
  {"Cov", 17282, 617},
  {"BaseIndices", 17432, 622},
  {"DeclareBaseIndices", 17532, 625},
  {"NDim", 17625, 628},
  {"BaseIndexQ", 17710, 631},
  {"MetricSimplify", 17805, 634},
  {"RawIndex", 17898, 637},
  {"SymbolicIndexQ", 17991, 640},
  {"ExtractFreeIndices", 18094, 643},
  {"RaiseIndex", 18193, 646},
  {"LowerIndex", 18284, 649},
  {"ReplaceIndex", 18377, 652},
  {"IndexFlavors", 18472, 655},
  {"DeclareIndexFlavor", 18573, 658},
  {"ClearIndexFlavor", 18678, 661},
  {"ToFlavor", 18773, 664},
  {"IndexFlavorQ", 18864, 667},
  {"UseCoordinates", 18961, 670},
  {"CoordinatesToTensors", 19066, 673},
  {"ArrayExpansion", 19171, 676},
  {"SumExpansion", 19268, 679},
  {"EinsteinSum", 19362, 682},
  {"EinsteinArray", 19457, 685},
  {"PartialSum", 19551, 688},
  {"PartialArray", 19644, 691},
  {"IndexChange", 19738, 694},
  {"UpDownSwap", 19830, 697},
  {"Symmetric", 19920, 700},
  {"AntiSymmetric", 20013, 703},
  {"DummySimplify", 20110, 706},
  {"SimplifyTensorSum", 20211, 709},
  {"MapLevelParts", 20312, 712},
  {"ParseTermIndices", 20412, 715},
  {"PartialD", 20507, 718},
  {"ExpandPartialD", 20600, 721},
  {"NondependentPartialD", 20705, 724},
  {"CovariantD", 20806, 727},
  {"ExpandCovariantD", 20903, 730},
  {"TotalD", 20996, 733},
  {"ExpandTotalD", 21085, 736},
  {"AbsoluteD", 21177, 739},
  {"ExpandAbsoluteD", 21273, 742},
  {"LieD", 21364, 745},
  {"ExpandLieD", 21450, 748},
  {"SetMetricValues", 21547, 751},
  {"SetMetricValueRules", 21653, 754},
  {"CalculateChristoffelu", 21765, 757},
  {"CalculateChristoffeld", 21879, 760},
  {"SetChristoffelValues", 21992, 763},
  {"SetChristoffelValueRules", 22108, 766},
  {"BasisDotProductRules", 22224, 769},
  {"ReverseBasisDotProductRules", 22343, 772},
  {"EvaluateDotProducts", 22461, 775},
  {"CircleEvalRule", 22566, 778},
  {"ConstructDirectProduct", 22674, 781},
  {"UsePartialDChainRule", 22788, 784},
  {"UseTotalDChainRule", 22898, 787},
  {"ContractArray", 23001, 790},
  {"ToArrayValues", 23099, 793},
  {"ContractKroneckers", 23202, 796},
  {"EvaluateSlots", 23305, 799},
  {"FullKroneckerExpand", 23409, 802},
  {"GenerateBasisTensors", 23520, 805},
  {"KroneckerAbsorb", 23627, 808},
  {"PermutationPseudotensor", 23737, 811},
  {"LeviCivitaDefinition3D", 23940, 816},
  {"LinearBreakout", 24048, 819},
  {"PartialKroneckerExpand", 24156, 822},
  {"PushOnto", 24258, 825},
  {"SymmetrizeSlots", 24353, 828}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 53, 0, 81, "Chapter"],
Cell[1810, 53, 75, 1, 42, "IndexSection",
  CellTags->"MasterIndexHeading"],

Cell[CellGroupData[{
Cell[1910, 58, 33, 0, 42, "IndexSection"],

Cell[CellGroupData[{
Cell[1968, 62, 133, 4, 17, "Index",
  CellTags->"Tensor"],
Cell[2104, 68, 143, 4, 17, "Index",
  CellTags->"Tensor"],
Cell[2250, 74, 160, 4, 17, "Index",
  CellTags->"SetTensorValues"],
Cell[2413, 80, 172, 4, 17, "Index",
  CellTags->"SetTensorValueRules"],
Cell[2588, 86, 163, 4, 17, "Index",
  CellTags->"TensorValueRules"],
Cell[2754, 92, 166, 4, 17, "Index",
  CellTags->"ClearTensorValues"],
Cell[2923, 98, 166, 4, 17, "Index",
  CellTags->"DeclareZeroTensor"],
Cell[3092, 104, 166, 4, 17, "Index",
  CellTags->"NonzeroValueRules"],
Cell[3261, 110, 178, 4, 17, "Index",
  CellTags->"DefineTensorShortcuts"],
Cell[3442, 116, 175, 4, 17, "Index",
  CellTags->"ClearTensorShortcuts"],
Cell[3620, 122, 127, 4, 17, "Index",
  CellTags->"Void"],
Cell[3750, 128, 124, 4, 17, "Index",
  CellTags->"Cov"],
Cell[3877, 134, 124, 4, 17, "Index",
  CellTags->"Cov"],
Cell[4004, 140, 148, 4, 17, "Index",
  CellTags->"BaseIndices"],
Cell[4155, 146, 169, 4, 17, "Index",
  CellTags->"DeclareBaseIndices"],
Cell[4327, 152, 127, 4, 17, "Index",
  CellTags->"NDim"],
Cell[4457, 158, 145, 4, 17, "Index",
  CellTags->"BaseIndexQ"],
Cell[4605, 164, 157, 4, 17, "Index",
  CellTags->"MetricSimplify"],
Cell[4765, 170, 139, 4, 17, "Index",
  CellTags->"RawIndex"],
Cell[4907, 176, 157, 4, 17, "Index",
  CellTags->"SymbolicIndexQ"],
Cell[5067, 182, 169, 4, 17, "Index",
  CellTags->"ExtractFreeIndices"],
Cell[5239, 188, 145, 4, 17, "Index",
  CellTags->"RaiseIndex"],
Cell[5387, 194, 145, 4, 17, "Index",
  CellTags->"LowerIndex"],
Cell[5535, 200, 151, 4, 17, "Index",
  CellTags->"ReplaceIndex"],
Cell[5689, 206, 151, 4, 17, "Index",
  CellTags->"IndexFlavors"],
Cell[5843, 212, 169, 4, 17, "Index",
  CellTags->"DeclareIndexFlavor"],
Cell[6015, 218, 163, 4, 17, "Index",
  CellTags->"ClearIndexFlavor"],
Cell[6181, 224, 139, 4, 17, "Index",
  CellTags->"ToFlavor"],
Cell[6323, 230, 151, 4, 17, "Index",
  CellTags->"IndexFlavorQ"],
Cell[6477, 236, 157, 4, 17, "Index",
  CellTags->"UseCoordinates"],
Cell[6637, 242, 175, 4, 17, "Index",
  CellTags->"CoordinatesToTensors"],
Cell[6815, 248, 157, 4, 17, "Index",
  CellTags->"ArrayExpansion"],
Cell[6975, 254, 151, 4, 17, "Index",
  CellTags->"SumExpansion"],
Cell[7129, 260, 148, 4, 17, "Index",
  CellTags->"EinsteinSum"],
Cell[7280, 266, 154, 4, 17, "Index",
  CellTags->"EinsteinArray"],
Cell[7437, 272, 145, 4, 17, "Index",
  CellTags->"PartialSum"],
Cell[7585, 278, 151, 4, 17, "Index",
  CellTags->"PartialArray"],
Cell[7739, 284, 148, 4, 17, "Index",
  CellTags->"IndexChange"],
Cell[7890, 290, 145, 4, 17, "Index",
  CellTags->"UpDownSwap"],
Cell[8038, 296, 142, 4, 17, "Index",
  CellTags->"Symmetric"],
Cell[8183, 302, 154, 4, 17, "Index",
  CellTags->"AntiSymmetric"],
Cell[8340, 308, 154, 4, 17, "Index",
  CellTags->"DummySimplify"],
Cell[8497, 314, 166, 4, 17, "Index",
  CellTags->"SimplifyTensorSum"],
Cell[8666, 320, 154, 4, 17, "Index",
  CellTags->"MapLevelParts"],
Cell[8823, 326, 163, 4, 17, "Index",
  CellTags->"ParseTermIndices"],
Cell[8989, 332, 139, 4, 17, "Index",
  CellTags->"PartialD"],
Cell[9131, 338, 157, 4, 17, "Index",
  CellTags->"ExpandPartialD"],
Cell[9291, 344, 175, 4, 17, "Index",
  CellTags->"NondependentPartialD"],
Cell[9469, 350, 145, 4, 17, "Index",
  CellTags->"CovariantD"],
Cell[9617, 356, 163, 4, 17, "Index",
  CellTags->"ExpandCovariantD"],
Cell[9783, 362, 133, 4, 17, "Index",
  CellTags->"TotalD"],
Cell[9919, 368, 151, 4, 17, "Index",
  CellTags->"ExpandTotalD"],
Cell[10073, 374, 142, 4, 17, "Index",
  CellTags->"AbsoluteD"],
Cell[10218, 380, 160, 4, 17, "Index",
  CellTags->"ExpandAbsoluteD"],
Cell[10381, 386, 127, 4, 17, "Index",
  CellTags->"LieD"],
Cell[10511, 392, 145, 4, 17, "Index",
  CellTags->"ExpandLieD"],
Cell[10659, 398, 160, 4, 17, "Index",
  CellTags->"SetMetricValues"],
Cell[10822, 404, 172, 4, 17, "Index",
  CellTags->"SetMetricValueRules"],
Cell[10997, 410, 178, 4, 17, "Index",
  CellTags->"CalculateChristoffelu"],
Cell[11178, 416, 178, 4, 17, "Index",
  CellTags->"CalculateChristoffeld"],
Cell[11359, 422, 175, 4, 17, "Index",
  CellTags->"SetChristoffelValues"],
Cell[11537, 428, 187, 4, 17, "Index",
  CellTags->"SetChristoffelValueRules"],
Cell[11727, 434, 175, 4, 17, "Index",
  CellTags->"BasisDotProductRules"],
Cell[11905, 440, 196, 4, 17, "Index",
  CellTags->"ReverseBasisDotProductRules"],
Cell[12104, 446, 172, 4, 17, "Index",
  CellTags->"EvaluateDotProducts"],
Cell[12279, 452, 157, 4, 17, "Index",
  CellTags->"CircleEvalRule"],
Cell[12439, 458, 181, 4, 17, "Index",
  CellTags->"ConstructDirectProduct"],
Cell[12623, 464, 175, 4, 17, "Index",
  CellTags->"UsePartialDChainRule"],
Cell[12801, 470, 169, 4, 17, "Index",
  CellTags->"UseTotalDChainRule"],
Cell[12973, 476, 154, 4, 17, "Index",
  CellTags->"ContractArray"],
Cell[13130, 482, 154, 4, 17, "Index",
  CellTags->"ToArrayValues"],
Cell[13287, 488, 169, 4, 17, "Index",
  CellTags->"ContractKroneckers"],
Cell[13459, 494, 154, 4, 17, "Index",
  CellTags->"EvaluateSlots"],
Cell[13616, 500, 172, 4, 17, "Index",
  CellTags->"FullKroneckerExpand"],
Cell[13791, 506, 175, 4, 17, "Index",
  CellTags->"GenerateBasisTensors"],
Cell[13969, 512, 160, 4, 17, "Index",
  CellTags->"KroneckerAbsorb"],
Cell[14132, 518, 184, 4, 17, "Index",
  CellTags->"PermutationPseudotensor"],
Cell[14319, 524, 182, 4, 17, "Index",
  CellTags->"PermutationPseudotensor"],
Cell[14504, 530, 181, 4, 17, "Index",
  CellTags->"LeviCivitaDefinition3D"],
Cell[14688, 536, 157, 4, 17, "Index",
  CellTags->"LinearBreakout"],
Cell[14848, 542, 181, 4, 17, "Index",
  CellTags->"PartialKroneckerExpand"],
Cell[15032, 548, 139, 4, 17, "Index",
  CellTags->"PushOnto"],
Cell[15174, 554, 160, 4, 17, "Index",
  CellTags->"SymmetrizeSlots"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

